# ------------------------------------------------------------------------------
# Faxspool frontend to create new faxes
# ------------------------------------------------------------------------------

# Window to create a new fax

proc do_createfax {} {
  global fineres alias_list short_list mgetty_dir fax_to coverpage_dir cover
  global normal_font bold_font
  global faxwin faxwin_name faxwin_geo plmwin

#.generate Window
  set faxwin_name ".palfax"
  set faxwin_geo  "608 354"

  set newwin [create_topwin faxwin]
  if ![string compare $newwin ""]  return \
  else {set faxwin $newwin}

  wm title    $faxwin "PalMail: Fax"
  wm iconname $faxwin "PalMail: Fax"
  wm minsize  $faxwin 608 354
  wm maxsize  $faxwin 608 354

#.widgets for the recipient
  pack [frame $faxwin.top -relief raised -borderwidth 1 -width 608 -height 92]
  label  $faxwin.top.tolabel  -text "fax To:" -underline 4 -font $normal_font
  place  $faxwin.top.tolabel  -x 13 -y 4
  label  $faxwin.top.tofield  -width 40 -background white -font $normal_font \
    -text [lindex $fax_to 0]
  place  $faxwin.top.tofield  -x 71 -y 4
  button $faxwin.top.add      -text "Add"    -width 7 -padx 2 -pady 2 \
    -font $normal_font -command {fax_command ADDALIAS} -underline 0
  place  $faxwin.top.add      -x 3 -y 28
  button $faxwin.top.remove   -text "Remove" -width 7 -padx 2 -pady 2 \
    -font $normal_font -command {fax_command DELALIAS} -underline 0
  place  $faxwin.top.remove   -x 3 -y 59
  listbox $faxwin.top.tolist  -height 3 -width 40 -font $normal_font \
    -yscrollcommand "$faxwin.top.toscroll set"
  place  $faxwin.top.tolist -x 69 -y 28
  scrollbar $faxwin.top.toscroll -orient vertical -width 14 \
    -command "$faxwin.top.tolist yview"
  place  $faxwin.top.toscroll -x 359 -y 28 -height 59

#.widgets for the coverpage
  label  $faxwin.top.coverlabel -text "Cover:" -underline 0 -font $normal_font
  place  $faxwin.top.coverlabel -x 382 -y 4
  label  $faxwin.top.coverfield -width 20 -background white -text $cover \
    -font $normal_font
  place  $faxwin.top.coverfield -x 433 -y 4
  listbox $faxwin.top.coverlist -height 3 -width 20 -font $normal_font \
    -yscrollcommand "$faxwin.top.coverscroll set"
  place  $faxwin.top.coverlist -x 431 -y 28
  scrollbar $faxwin.top.coverscroll -orient vertical -width 14 \
    -command "$faxwin.top.coverlist yview"
  place  $faxwin.top.coverscroll -x 581 -y 28 -height 59

#.widgets for the memo-box
  pack [frame $faxwin.memo -width 608 -height 162]
  label $faxwin.memo.label -text "Memo:" -underline 0 -font $normal_font
  place $faxwin.memo.label -x 12 -y 70
  text  $faxwin.memo.text -width 72 -height 11 -pady 3 -font $bold_font \
    -background white -relief sunken -borderwidth 1 \
    -yscrollcommand "$faxwin.memo.scroll set"
  place $faxwin.memo.text -x 70 -y 3 -height 156
  scrollbar $faxwin.memo.scroll -orient vertical -width 14 \
    -command "$faxwin.memo.text yview"
  place  $faxwin.memo.scroll -x 582 -y 3 -height 156

#.file selection
  pack [frame $faxwin.file -relief raised -borderwidth 1 -width 608 -height 67]
  button $faxwin.file.add    -text "File"   -width 7 -padx 2 -pady 2 \
    -command {fax_command ADDFILE} -underline 0 -font $normal_font
  place  $faxwin.file.add    -x 3 -y 3
  button $faxwin.file.remove -text "Delete" -width 7 -padx 2 -pady 3 \
    -command {fax_command DELFILE} -underline 0 -font $normal_font
  place  $faxwin.file.remove -x 3 -y 33 -height 29
  listbox $faxwin.file.list -height 3 -width 70 -selectmode extended \
    -yscrollcommand "$faxwin.file.scroll set" -font $bold_font
  place  $faxwin.file.list -x 69 -y 3 -width 512 -height 59
  scrollbar $faxwin.file.scroll -orient vertical -width 14 \
    -command "$faxwin.file.list yview"
  place  $faxwin.file.scroll -x 581 -y 3 -height 59

#.buttons
  pack [frame $faxwin.but -width 608 -height 33]
  button $faxwin.but.ok -text "Spool" -width 7 -padx 2 -pady 2 \
    -font $normal_font -command {fax_command OK} -underline 0
  place $faxwin.but.ok -x 4 -y 3
  button $faxwin.but.cancel -text "Exit" -width 7 -padx 2 -pady 2 \
    -font $normal_font -command {fax_command CANCEL}
  place $faxwin.but.cancel -x 70 -y 3
  set fineres 1
  checkbutton $faxwin.but.fineres -relief flat
  place $faxwin.but.fineres -x 586 -y 4 -width 20
  label $faxwin.but.finereslabel -text "fIne resolution" -underline 1 \
    -font $normal_font
  place $faxwin.but.finereslabel -x 488 -y 7
#.status line
  label $faxwin.but.status -foreground red -font $normal_font
  place $faxwin.but.status -x 140 -y 7
  entry $faxwin.but.entry -width 32 -font $normal_font

  faxwin_bindings_on

#.read fax aliases
#.first entry wins over later entries with the same short name
  set alias_list ""
  set short_list ""
#.read local aliases first
  load_aliases "~/.faxnrs" "l"
  load_aliases "$mgetty_dir/faxaliases" "g"
  set alias_list [lsort $alias_list]
  $faxwin.top.tolist delete 0 end
  foreach elem $alias_list {
    $faxwin.top.tolist insert end \
      "[lindex $elem 0] ([lindex $elem 1], [lindex $elem 2])"
  }

#.look for coverpages
  $faxwin.top.coverlist delete 0 end
  $faxwin.top.coverlist insert end "no cover"
  foreach i [lsort [glob -nocomplain "$coverpage_dir/*"]] {
    if {[file isfile $i] && [file executable $i]} {
      $faxwin.top.coverlist insert end [file tail $i]
    }
  }

#.set the input focus
  tkwait visibility $faxwin.top.tolist
  focus $faxwin.top.tolist

#.wait for Exit
  tkwait window $faxwin
  return
}


# Enable standard faxwindow bindings

proc faxwin_bindings_on {} {
  global faxwin alt_key entry_active

  $faxwin.top.add            configure -state normal
  $faxwin.top.remove         configure -state normal
  $faxwin.memo.text          configure -state normal
  $faxwin.file.add           configure -state normal
  $faxwin.file.remove        configure -state normal
  $faxwin.but.ok             configure -text "Spool" -underline 0
  $faxwin.but.cancel         configure -text "Exit"
  bind $faxwin               <$alt_key-t>      {focus $faxwin.top.tolist}
  bind $faxwin               <$alt_key-c>      {focus $faxwin.top.coverlist}
  bind $faxwin               <$alt_key-m>      {focus $faxwin.memo.text}
  bind $faxwin               <$alt_key-a>      {fax_command ADDALIAS}
  bind $faxwin               <$alt_key-r>      {fax_command DELALIAS}
  bind $faxwin               <$alt_key-f>      {fax_command ADDFILE}
  bind $faxwin               <$alt_key-d>      {fax_command DELFILE}
  bind $faxwin               <$alt_key-s>      {fax_command OK}
  bind $faxwin               <$alt_key-i>      {$faxwin.but.fineres invoke}
  bind $faxwin               <$alt_key-e>      {fax_command CANCEL}
  bind $faxwin               <Escape>          {fax_command CANCEL}
  bind $faxwin.top.tolist    <Double-Button-1> {fax_command ALIAS}
  bind $faxwin.top.tolist    <Return>          {fax_command ALIAS}
  bind $faxwin.top.coverlist <Double-Button-1> {fax_command COVER}
  bind $faxwin.top.coverlist <Return>          {fax_command COVER}
  place forget $faxwin.but.entry
  set entry_active 0
  status_line ""
}


# Disable standard faxwindow bindings

proc faxwin_bindings_off {} {
  global faxwin alt_key entry_active

  $faxwin.top.add            configure -state disabled
  $faxwin.top.remove         configure -state disabled
  $faxwin.memo.text          configure -state disabled
  $faxwin.file.add           configure -state disabled
  $faxwin.file.remove        configure -state disabled
  $faxwin.but.ok             configure -text "OK" -underline -1
  $faxwin.but.cancel         configure -text "Cancel"
  bind $faxwin.top.tolist    <Double-Button-1> {}
  bind $faxwin.top.tolist    <Return>          {}
  bind $faxwin.top.coverlist <Double-Button-1> {}
  bind $faxwin.top.coverlist <Return>          {}
  bind $faxwin               <$alt_key-t>      {}
  bind $faxwin               <$alt_key-c>      {}
  bind $faxwin               <$alt_key-m>      {}
  bind $faxwin               <$alt_key-a>      {}
  bind $faxwin               <$alt_key-r>      {}
  bind $faxwin               <$alt_key-f>      {}
  bind $faxwin               <$alt_key-d>      {}
  bind $faxwin               <$alt_key-s>      {}
  bind $faxwin               <$alt_key-i>      {}
  bind $faxwin               <$alt_key-e>      {}
  bind $faxwin               <Escape>          {set ready -1}
  bind $faxwin.but.entry     <Return>          {set ready  1}
  set entry_active 1
}


# Status line for messages in the fax box

proc status_line {line} {
  global faxwin

  $faxwin.but.status configure -width 48 -text "$line"
  update idletasks
}


# Handle user input from the fax box

proc fax_command {Mode} {
  global faxwin fax_to alias_list entry_active ready cover busy
  global userfax_dir startdir

  if {!$busy} {status_line ""}
  if ![string compare $Mode "CANCEL"] {
#...user requested CANCEL. 
    if $entry_active {set ready -1 ; return}
    destroy $faxwin
  } elseif ![string compare $Mode "OK"] {
#...user requested OK / Spool
    if $entry_active {set ready  1 ; return}
    spool_fax
  } elseif ![string compare $Mode "ALIAS"] {
#...user pushed Double Button 1 in the fax alias list
    if ![string compare [$faxwin.top.tolist curselection] ""]  return
    set fax_to [lindex $alias_list [$faxwin.top.tolist curselection]]
    $faxwin.top.tofield configure -text [lindex $fax_to 0]
  } elseif ![string compare $Mode "COVER"] {
#...user pushed Double Button 1 in the coverpage list
    if ![string compare [$faxwin.top.coverlist curselection] ""]  return
    set cover [$faxwin.top.coverlist get [$faxwin.top.coverlist curselection]]
    $faxwin.top.coverfield configure -text $cover
  } elseif ![string compare $Mode "ADDALIAS"] {
    create_alias
  } elseif ![string compare $Mode "DELALIAS"] {
    del_alias
  } elseif ![string compare $Mode "ADDFILE"] {
#...add a file to be spooled within the fax
    set startdir $userfax_dir
    set filename [select_file $userfax_dir]
    set userfax_dir $startdir
#...does the fax-window still exist?
    if [winfo exists $faxwin] {
      if {[file isfile $filename] && [file readable $filename]} {
        $faxwin.file.list insert end $filename
      } elseif [string compare $filename ""] {
        status_line "illegal file"
      }
    }
  } elseif ![string compare $Mode "DELFILE"] {
#...remove a filename from the file list
    set items [$faxwin.file.list curselection]
    set count 0
    foreach i $items {
      $faxwin.file.list delete [expr $i-$count]
      incr count
    }
  }
  return
}


# Load fax alias file

proc load_aliases {alias_file mode} {
  global alias_list short_list

  if ![file readable $alias_file] {return 0}
  if {[catch {open $alias_file r} file_id]} {return 0}
  while {![eof $file_id]} {
    gets $file_id line
    if [string compare "$line" ""] {
#.....remove leading spaces
      set line [string trimleft $line]
#.....ignore comments
      if {[string index $line 0] != "\#"} {
#.......remove white space
        set line_list ""
        foreach elem [split $line] {
          if [string compare $elem ""] {lappend line_list $elem}
        }
        set short_name [lindex $line_list 0]
        set fax_number [lindex $line_list 1]
        set full_name  [lrange $line_list 2 end]
        if ![string compare "$full_name" ""] {set full_name "$short_name"}
        if {[lsearch $short_list $short_name] != -1} {
          status_line "short name $short_name already exists"
        } else {
          set alias_elem [list "$full_name" "$short_name" "$fax_number" "$mode"]
          lappend alias_list $alias_elem
          lappend short_list $short_name
        }
      }
    }
  }
  catch {close $file_id}
}


# Save the local alias file

proc save_aliases {} {
  global alias_list

  set alias_file "~/.faxnrs"
  if {[catch {open $alias_file w} file_id]} {
    status_line "Can't write to $alias_file"
  } else {
    foreach entry "$alias_list" {
      if {[lindex "$entry" 3] == "l"} {
        set full_name  [lindex "$entry" 0]
        set short_name [lindex "$entry" 1]
        set fax_number [lindex "$entry" 2]
        puts $file_id "$short_name $fax_number $full_name"
      }
    }
    catch {close $file_id}
  }
}


# Add a new fax alias to the local alias file

proc create_alias {} {
  global faxwin alias_list short_list ready

#.disable other widgets
  faxwin_bindings_off
#.ask for the short name
  $faxwin.but.status configure -width 11 -text "short name:"
  $faxwin.but.entry delete 0 end
  place $faxwin.but.entry -x 230 -y 5
  focus $faxwin.but.entry
  set ready 0
  tkwait variable ready
  if {$ready == -1} {faxwin_bindings_on ; return}
  set short_name [lindex [split [$faxwin.but.entry get]] 0]
  if ![string compare $short_name ""] {
    faxwin_bindings_on
    status_line "no short name entered"
    return
  }
#.if the short name already exists, switch to edit mode
  set existing_alias [lsearch $short_list $short_name]
  if {[lsearch $short_list $short_name] != -1} {
#...look for the short name in the alias database
    foreach old_alias "$alias_list" {
      if ![string compare [lindex $old_alias 1] $short_name]  break
    }
#...is it a local alias?
    if {[lindex $old_alias 3] != "l"} {
      faxwin_bindings_on
      status_line "can't edit global alias $short_name"
      return
    }
    set edit_alias 1
  } else {
    set edit_alias 0
  }
#.ask for the full name
  $faxwin.but.status configure -width 11 -text "full name:"
  $faxwin.but.entry delete 0 end
  if $edit_alias {$faxwin.but.entry insert 0 [lindex $old_alias 0]}
  set ready 0
  tkwait variable ready
  if {$ready == -1} {faxwin_bindings_on ; return}
  set full_name [$faxwin.but.entry get]
#.ask for the fax number
  $faxwin.but.status configure -width 11 -text "fax number:"
  $faxwin.but.entry delete 0 end
  if $edit_alias {$faxwin.but.entry insert 0 [lindex $old_alias 2]}
  set ready 0
  tkwait variable ready
  focus $faxwin.top.tolist
  if {$ready == -1} {faxwin_bindings_on ; return}
  set fax_number [$faxwin.but.entry get]
  $faxwin.but.entry delete 0 end
  faxwin_bindings_on
  if ![string compare $fax_number ""] {
    status_line "no fax number entered"
    return
  }
  set alias_elem [list "$full_name" "$short_name" "$fax_number" "l"]
  if $edit_alias {
#...remove old alias from the alias_list
    set old_alias_list $alias_list
    set alias_list ""
    foreach alias $old_alias_list {
      if [string compare [lindex $alias 1] $short_name] {lappend alias_list $alias}
    }
  }
  lappend alias_list $alias_elem
  set alias_list [lsort $alias_list]
  if !$edit_alias {lappend short_list $short_name}
  save_aliases
#.update listbox
  $faxwin.top.tolist delete 0 end
  foreach elem $alias_list {
    $faxwin.top.tolist insert end \
      "[lindex $elem 0] ([lindex $elem 1], [lindex $elem 2])"
  }
}


# Remove a fax alias from the local alias file and the alias listbox

proc del_alias {} {
  global faxwin alias_list short_list fax_to ready

  set item [$faxwin.top.tolist curselection]
  if ![string compare $item ""]  return
  set elem [lindex $alias_list $item]
  if {[lindex $elem 3] == "l"} {
#...OK, it's a local alias: ask the user to confirm
    faxwin_bindings_off
    status_line "Remove selected alias \"[lindex $elem 1]\" ?"
    set ready 0
    focus $faxwin.but.ok
    tkwait variable ready
    faxwin_bindings_on
    focus $faxwin.top.tolist
    if {$ready == -1}  return
    if {$fax_to == $elem} {
#.....the selected alias was the active recipient
      set fax_to ""
      $faxwin.top.tofield configure -text ""
    }
#...remove item from the listbox
    $faxwin.top.tolist delete $item
#...remove item from the alias_list
    set alias_list [del_listitem $alias_list $item]
#...remove short name from the short_list
    set old_short_list $short_list
    set short_list ""
    foreach short_name $old_short_list {
      if {$short_name != [lindex $elem 1]} {lappend short_list $short_name}
    }
#...save local alias file
    save_aliases
  } else {
    status_line "Can't remove global alias"
  }
}


# Spool the new fax

proc spool_fax {} {
  global faxwin plmwin fax_to coverpage_dir cover fineres busy alt_key
  global convert_dvi dvips_mode_n dvips_mode_f argv0 curr_mode

  set known_fmts [list .g3 .ps .eps .cps .dvi .pbm .pgm .ppm .pgm .ppm\
                       .t .txt .asc .lj .pcl .xwd .gif .tif .tiff]

  if ![string compare "$fax_to" ""] {
    status_line "No recipient chosen"
    return
  }
  set memo_text [$faxwin.memo.text get 1.0 end]
  if {[$faxwin.file.list size] == 0 && ![string compare $memo_text "\n"]} {
    status_line "No file selected or memo entered"
    return
  }
#.disable widgets
  set busy 1
  faxwin_bindings_off
  $faxwin.but.ok     configure -text "Spool" -state active -relief sunken
  $faxwin.but.cancel configure -text "Exit"  -state disabled
#.start values
  set curr_dir [pwd]
  set args ""
  if $fineres {
    set dvips_mode "$dvips_mode_f"
  } else {
    lappend args "-n"
    set dvips_mode "$dvips_mode_n"
  }
  set selected_files ""
#.create memo-file /tmp/PalMemo.txt if necessary
  set memo_file "/tmp/PalMemo.txt"
  set tmp_files ""
  set use_cover $cover
  if [string compare $memo_text "\n"] {
    if {[catch {open $memo_file w} file_id]} {
      status_line "Can't write to $memo_file"
    } else {puts $file_id "$memo_text"}
    catch {close $file_id}
    set tmp_files [list $memo_file]
#...spool the memo text as normal ascii file, if no cover is specified
    if ![string compare $cover "no cover"] {
      lappend selected_files $memo_file
      set memo_cmd ""
    } else {
      set memo_cmd " -m $memo_file"
    }
  } else {set memo_cmd ""}
  if ![string compare $use_cover "no cover"] {set cover_cmd ""} \
  else {
    lappend args "-C"
    lappend args "$coverpage_dir/$use_cover$memo_cmd"
  }
  lappend args [lindex $fax_to 1]
  set count 0
  set selected_files [concat $selected_files [$faxwin.file.list get 0 end]]
  foreach f $selected_files {
    incr count
    set f_tail [file tail $f]
    if {$convert_dvi && [file extension $f] == ".dvi"} {
#.....convert dvi-files here to include all graphics
      set dvi_dir [file dirname $f]
      if {$dvi_dir == ""} {set dvi_dir "/"}
      cd $dvi_dir
      status_line "converting dvi-files ..."
      set new_file /tmp/Pal$count.[file rootname $f_tail].ps
      set dvips_args [concat [split $dvips_mode] [list $f -o $new_file]]
      exec_cmd dvips $dvips_args dvips_pid wait
      cd $curr_dir
      lappend args      $new_file
      lappend tmp_files $new_file
    } elseif ![string compare $f ""] {
#.....ignore empty lines
    } elseif {[lsearch $known_fmts [file extension $f]] == -1} {
#.....force ascii mode if it's not a known format
      set new_file /tmp/Pal$count.$f_tail.asc
      catch "eval exec cp $f $new_file"
      lappend args      $new_file
      lappend tmp_files $new_file
      set f $new_file
    } elseif ![string compare [string index $f_tail 0] '.'] {
#.....remove leading '.' which confuse faxspool
      set new_file /tmp/Pal$count.$f_tail
      catch "eval exec cp $f $new_file"
      lappend args      $new_file
      lappend tmp_files $new_file
      set f $new_file
    } else {
      lappend args $f
    }
  }
#.execute faxspool-command
  status_line "spooling ..."
  exec_cmd faxspool $args faxspool_pid wait
#.remove temporary files
  foreach i $tmp_files {catch "eval exec rm -f $i"}
  if {[string compare [file tail $argv0] "PalFax"] && $curr_mode == "FaxOUT"} {
    $plmwin.button.update invoke
  }
#.enable widgets again
  faxwin_bindings_on
  $faxwin.but.ok     configure -state normal -relief raised
  $faxwin.but.cancel configure -state normal
  set busy 0
}

