# PalMail 0.98 -- a frontend for Voice/FAX/DTMF messages.
#
# Copyleft  (C) 1995-1997 Tim Bandelow <Tim.Bandelow@Materna.DE>
#                         Sven Palme   <palme@elphy.irz.hu-berlin.de>
#
# PalMail was originally based on an old version of faxview by Ralph Schleicher
# Copyright (C) 1994,1995 Ralph Schleicher <rs@purple.UL.BaWue.DE>
#
# Some parts are loosely based on XTeXShell, Version 0.91 (21.2.94)
# Copyright (C) 1994      Michael Hofmann <hofmann@mzdmza.zdv.uni-mainz.de>
#
# Some parts are loosely based on xtem_texmenu, Version 4.16
# Copyright (C) 1994      G.Lamprecht, W.Lotz, R.Weibezahn; LRW c/o Uni Bremen
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# ------------------------------------------------------------------------------

if ![string compare [info commands update_ringlog_c] ""] {
  puts ""
  puts "  THIS FILE CAN'T BE RUN DIRECTLY !"
  puts "     YOU MUST COMPILE IT FIRST !"
  puts ""
  exit
}

# ------------------------------------------------------------------------------
# Default Configuration
# ------------------------------------------------------------------------------

set palmail_dir /usr/local/lib/PalMail
set wm_title    "PalMail 0.98"

# ------------------------------------------------------------------------------
# Everything below this line should be configured in the configuration files !!!
# ------------------------------------------------------------------------------

# file-permissions
# ----------------
set file_mod 660
set file_grp phone

# directories
# -----------
set ringlog_dir   /var/log
set vocin_dir     /var/spool/voice/incoming
set vocout_dir    /var/spool/voice/messages
set DTMF_dir      /var/spool/voice/dtmf
set faxin_dir     /var/spool/fax/incoming
set faxout_dir    /var/spool/fax/outgoing
set mgetty_dir    /usr/local/etc/mgetty+sendfax
set userfax_dir   .
set uservoc_dir   .

set hostfile_dir  $palmail_dir
set coverpage_dir $palmail_dir/coverpgs

# some file-names
# ---------------
set ringlog_name  ringlog
set hostfile_name in-hosts

set modem         modem

set mgetty_pid    /etc/mg-pid.$modem

set mgetty_log    /tmp/log_mg.$modem

set lock_file     /var/lock/LCK..$modem
set index_file    $vocout_dir/Index
set DTMF_file     $DTMF_dir/Index
set faxdb_file    $palmail_dir/faxdb
set tmp_dir       /tmp
set tmp_file      $tmp_dir/PalMail.tmp

# commands
# ----------------------
set do_View_n_command       {viewfax -n $f}
set do_View_f_command       {viewfax $f}
set do_Print_n_command      {g3tolj -aspect 2.0 $f | lpr -Praw}
set do_Print_f_command      {g3tolj $f | lpr -Praw}

set do_Connect_command      {/usr/local/bin/$f.on}
set do_DisConnect_command   {/usr/local/bin/disconnect}

set play_cmd                "$palmail_dir/do_play"

set do_Play_command         {vm play -s $f}
set do_Record_command       {vm record -m $f}
set do_StopPlay_command     "killall -2 vm"
set do_StopRecord_command   "killall -2 vm"

set do_Play_command2        {rmdtopvf $f | pvfspeed -s 8000 | pvftoau > /dev/audio}
set do_Record_command2      {vrec -w -b 16 -s 8000 | wavtopvf | pvfspeed -s 7200 | pvftormd Rockwell 4 > $f}
set do_StopPlay_command2    "killall -9 pvftoau"
set do_StopRecord_command2  "killall -9 vrec"

set do_FromAu_command       "autopvf    | pvfspeed -s 7200 | pvftormd Rockwell 4"
set do_FromWav_command      "wavtopvf   | pvfspeed -s 7200 | pvftormd Rockwell 4"
set do_FromVoc_command      "voctopvf   | pvfspeed -s 7200 | pvftormd Rockwell 4"
set do_FromLin_command      "lintopvf   | pvfspeed -s 7200 | pvftormd Rockwell 4"
set do_FromBasic_command    "basictopvf | pvfspeed -s 7200 | pvftormd Rockwell 4"
set do_FromRmd_command      "cat"
set do_ToAu_command         "rmdtopvf   | pvfspeed -s 8000 | pvftoau"
set do_ToWav_command        "rmdtopvf   | pvfspeed -s 8000 | pvftowav"
set do_ToVoc_command        "rmdtopvf   | pvfspeed -s 8000 | pvftovoc"
set do_ToLin_command        "rmdtopvf   | pvfspeed -s 8000 | pvftolin"
set do_ToBasic_command      "rmdtopvf   | pvfspeed -s 8000 | pvftobasic"
set do_ToRmd_command        "cat"

set do_Ata_command          "$palmail_dir/do_ata \$pid"
set do_Crop_command         "g3hack"
set do_Faxrunq_command      "$palmail_dir/do_faxrunq"

# file masks
# ----------
set FaxIN_mask     {f[nf]*.??}
set FaxOUT_mask    {F*}
set VocIN_mask1    {voc--??.??.??--??:??:??--*}
set VocIN_mask2    {voc-??????*}
set VocIN_mask3    {va?????.rmd*}

# do you want all pages of an incoming fax to be displayed together on startup?
set show_multi     1

#   do you want to play/record sound file on your modem as startup mode
set use_modem      1

# do you want PalMail to convert dvi-files itself before spooling them?
# this should fix problems with included graphics
set convert_dvi    1
set dvips_mode_n "-P dfaxlow"
set dvips_mode_f "-P dfaxhigh"

# automatically update the ringlog file every ... seconds
set update_time   120

# english file time layout "Tue, Feb 20 96, 10:00"
set time_fmt ", %b %d %y, %H:%M"
set weekdays [list Sun Mon Tue Wed Thu Fri Sat]

# some key-names
# --------------
# your Alt-Key-modifier (Should be one of Alt / Meta / Mod1 - Mod5 / Control)
set alt_key    Mod1
# scrolling the log-box:
set shift_up   KP_8
set shift_down KP_2

# ------------------------------------------------------------------------------
# Basic Initialization.
# ------------------------------------------------------------------------------

# Set the defaults.
set color_foreground  black
set color_background  lightgrey
set color_disabled    maroon
set color_ground      grey
set color_input       white
set color_selection   maroon

set normal_font  "-*-helvetica-bold-r-normal--12-120-75-75-p-70-iso8859-1"
set list_font    "7x14bold"
set fixed_font   "fixed"
set bold_font    "-*-fixed-bold-r-normal--13-120-75-75-c-70-iso8859-1"

. configure -borderwidth 4 -background $color_background
option add Tk*background $color_background
option add Tk*selectBackground $color_selection
option add Tk*selectForeground $color_input

# remove the unneeded window
wm withdraw .

set curr_pwd [pwd]

# load configuration files
load_config $palmail_dir/PalMail.cfg
load_config ~/.PalMail
cd
if {"$curr_pwd" != [pwd]} {load_config ./.PalMail}
cd $curr_pwd
load_config ./PalMail.cfg

# ------------------------------------------------------------------------------
# Structure of the user interface
# ------------------------------------------------------------------------------

# [list Mode Key Dir Filetype [list [list button ButtonName ButtonAction Key ] ... ] ]
# button can be: 0 1 2 3 4 5 6
# and should be: update

set mmail_mode [list \
                    [list Ring \
                         <$alt_key-r> \
                         $ringlog_dir \
                         $ringlog_name \
                         [list \
                              [list \
                                   0 \
                                   Auto \
                                   do_entry_auto <a>] \
                              [list \
                                   1 \
                                   Stop \
                                   do_stop <s>] \
                              [list \
                                   2 \
                                   Rename \
                                   do_entry_rename <r>] \
                              [list \
                                   3 \
                                   Delete \
                                   do_entry_remove <d>] \
                              [list \
                                   4 \
                                   Clear \
                                   do_file_clear <c>] \
                              [list \
                                   5 \
                                   "Pick Up" \
                                   do_ata <p>] \
                              [list \
                                   update \
                                   Update \
                                   do_ringlog_update <u>] \
                         ] \
                    ] \
                    [list VocIN \
                         <$alt_key-v> \
                         $vocin_dir \
                         * \
                         [list \
                              [list \
                                   0 \
                                   Play \
                                   do_play <p>] \
                              [list \
                                   1 \
                                   Stop \
                                   do_stop <s>] \
                              [list \
                                   2 \
                                   Export \
                                   do_export_voc <e>] \
                              [list \
                                   3 \
                                   Rename \
                                   do_rename <r>] \
                              [list \
                                   4 \
                                   Delete \
                                   do_remove <d>] \
                              [list \
                                   update \
                                   Update \
                                   do_VocFaxIN_update <u>] \
                         ] \
                    ] \
                    [list VocOUT \
                         <$alt_key-V> \
                         $vocout_dir \
                         * \
                         [list \
                              [list \
                                   0 \
                                   Play \
                                   do_play <p>] \
                              [list \
                                   1 \
                                   Stop \
                                   do_stop <s>] \
                              [list \
                                   2 \
                                   Record \
                                   do_record <r>] \
                              [list \
                                   3 \
                                   Import \
                                   do_import_voc <i>] \
                              [list \
                                   4 \
                                   Activate \
                                   do_activate <a>] \
                              [list \
                                   5 \
                                   reName \
                                   do_rename <n>] \
                              [list \
                                   6 \
                                   Delete \
                                   do_remove <d>] \
                              [list \
                                   update \
                                   Update \
                                   do_VocOUT_update <u>] \
                         ] \
                    ] \
                    [list DTMF \
                         <$alt_key-d> \
                         $DTMF_dir \
                         * \
                         [list \
                              [list \
                                   0 \
                                   Play \
                                   do_play <p>] \
                              [list \
                                   1 \
                                   Stop \
                                   do_stop <s>] \
                              [list \
                                   2 \
                                   Record \
                                   do_record <r>] \
                              [list \
                                   3 \
                                   Import \
                                   do_import_voc <i>] \
                              [list \
                                   4 \
                                   Activate \
                                   do_DTMF_activate <a>] \
                              [list \
                                   5 \
                                   reName \
                                   do_DTMF_rename <n>] \
                              [list \
                                   6 \
                                   Delete \
                                   do_DTMF_remove <d>] \
                              [list \
                                   update \
                                   Update \
                                   do_DTMF_update <u>] \
                         ] \
                    ] \
                    [list FaxIN \
                         <$alt_key-f> \
                         $faxin_dir \
                         $FaxIN_mask \
                         [list \
                              [list \
                                   0 \
                                   View \
                                   "do_fax View" <v>] \
                              [list \
                                   1 \
                                   Print \
                                   "do_fax Print" <p>] \
                              [list \
                                   2 \
                                   "Add DB" \
                                   do_add_sender <a>] \
                              [list \
                                   3 \
                                   Delete \
                                   do_remove <d>] \
                              [list \
                                   update \
                                   Update \
                                   do_VocFaxIN_update <u>] \
                         ] \
                    ] \
                    [list FaxOUT \
                         <$alt_key-F> \
                         $faxout_dir \
                         $FaxOUT_mask \
                         [list \
                              [list \
                                   0 \
                                   View \
                                   "do_fax View" <v>] \
                              [list \
                                   1 \
                                   Print \
                                   "do_fax Print" <p>] \
                              [list \
                                   2 \
                                   "New Fax" \
                                   do_createfax <n>] \
                              [list \
                                   3 \
                                   Crop \
                                   do_crop <c>] \
                              [list \
                                   4 \
                                   Suspend \
                                   do_suspend <s>] \
                              [list \
                                   5 \
                                   Delete \
                                   do_fremove <d>] \
                              [list \
                                   6 \
                                   "Faxrunq" \
                                   "do_faxrunq" <f>] \
                              [list \
                                   update \
                                   Update \
                                   do_FaxOUT_update <u>] \
                         ] \
                    ] \
                    [list Connect \
                         <$alt_key-c> \
                         $hostfile_dir \
                         $hostfile_name \
                         [list \
                              [list \
                                   0 \
                                   Connect \
                                   do_connect <c>] \
                              [list \
                                   1 \
                                   Off \
                                   do_disconnect <o>] \
                              [list \
                                   2 \
                                   Add \
                                   do_add_host <a>] \
                              [list \
                                   3 \
                                   Delete \
                                   do_entry_remove <d>] \
                              [list \
                                   update \
                                   Update \
                                   do_file_update <u>] \
                         ] \
                    ] \
]

# ------------------------------------------------------------------------------
# Create the rmdplay/rmdrec scripts
# ------------------------------------------------------------------------------

proc create_play_script {} {
  global do_Play_command do_Play_command2
  global do_StopPlay_command do_StopPlay_command2
  global do_Record_command do_Record_command2
  global do_StopRecord_command do_StopRecord_command2
  global play_cmd

#.create script to play soundfiles
  if [catch {open $play_cmd w} file_id] {
    log_entry "$play_cmd: error writing file"
  } else {
    puts $file_id "#!/bin/bash"
    puts $file_id "# This file is automatically generated. DO NOT EDIT !"
    puts $file_id "if \[ \"\$3\" = \"\" \] ; then"
    puts $file_id "  echo \"  usage:  do_play play/rec modem/soundcard files\""
    puts $file_id "  exit"
    puts $file_id "fi"
    puts $file_id "mode=\$1"
    puts $file_id "device=\$2"
    puts $file_id "shift"
    puts $file_id "shift"
    puts $file_id "if \[ \"\$mode\" = \"play\" \] ; then"
    puts $file_id "  if \[ \"\$device\" = \"modem\" \] ; then"
    puts $file_id "    trap \"$do_StopPlay_command\" 10"
    puts $file_id "    trap \"$do_StopPlay_command ; exit\" 2"
    puts $file_id "    for f in \$* ; do"
    puts $file_id "      $do_Play_command &"
    puts $file_id "      wait"
    puts $file_id "    done"
    puts $file_id "  elif \[ \"\$device\" = \"soundcard\" \] ; then"
    puts $file_id "    trap \"$do_StopPlay_command2\" 10"
    puts $file_id "    trap \"$do_StopPlay_command2 ; exit\" 2"
    puts $file_id "    for f in \$* ; do"
    puts $file_id "      $do_Play_command2 &"
    puts $file_id "      wait"
    puts $file_id "    done"
    puts $file_id "  else"
    puts $file_id "    echo Unknown device \$device"
    puts $file_id "  fi"
    puts $file_id "elif \[ \"\$mode\" = \"rec\" \] ; then"
    puts $file_id "  f=\$1"
    puts $file_id "  if \[ \"\$device\" = \"modem\" \] ; then"
    puts $file_id "    trap \"$do_StopRecord_command\" 10"
    puts $file_id "    trap \"$do_StopRecord_command ; exit\" 2"
    puts $file_id "    $do_Record_command &"
    puts $file_id "    wait"
    puts $file_id "  elif \[ \"\$device\" = \"soundcard\" \] ; then"
    puts $file_id "    trap \"$do_StopRecord_command2\" 10"
    puts $file_id "    trap \"$do_StopRecord_command2 ; exit\" 2"
    puts $file_id "    $do_Record_command2 &"
    puts $file_id "    wait"
    puts $file_id "  else"
    puts $file_id "    echo Unknown device \$device"
    puts $file_id "  fi"
    puts $file_id "else"
    puts $file_id "  echo Unknown mode \$mode"
    puts $file_id "fi"
    catch {close $file_id}
    catch {exec chmod 755 $play_cmd}
  }
}

# ------------------------------------------------------------------------------
# Main program
# ------------------------------------------------------------------------------

set fax_to ""
set cover "no cover"
set busy 0

# expand user paths
cd $userfax_dir
set userfax_dir [pwd]
cd $uservoc_dir
set uservoc_dir [pwd]
cd $curr_pwd

# check do_Play_command and do_Record_command for old syntax (without $f)
if {[string first "\$f" "$do_Play_command"] == -1} {
  set do_Play_command "$do_Play_command \$f"
}
if {[string first "\$f" "$do_Record_command"] == -1} {
  set do_Record_command "$do_Record_command \$f"
}

# directly run the faxspool-frontend, if PalMail is invoked as `PalFax'
if {[file tail $argv0] == "PalFax"} {
  do_createfax
  exit
} else {
  main_window
  create_play_script
#.start automatical update
  after ${update_time}000 {auto_update}
}

# ------------------------------------------------------------------------------
# The End
# ------------------------------------------------------------------------------
