# ------------------------------------------------------------------------------
# Connect-Commands
# ------------------------------------------------------------------------------

# Establish a DIP- or SLIP-connection

proc do_connect {} {
  global do_Connect_command connect_finished curr_mode plmwin

  if !$connect_finished {return 0}
  set items [listbox_selection]
  if {$items == ""} {return 0}
  set f [$plmwin.display.listbox get [lindex $items 0]]
  log_entry "$f: Connecting. Please wait ..."
  if [stop_play] {
    eval set command "$do_Connect_command"
    set cmd  [lindex [split $command] 0]
    set args [lrange [split $command] 1 end]
    exec_cmd $cmd $args pid
    set connect_finished 0
  }
}


# Stop DIP- / SLIP-connection

proc do_disconnect {} {
  global do_DisConnect_command connect_finished curr_mode
  log_entry "Disconnecting"
  catch "eval exec $do_DisConnect_command"
  set connect_finished 1
}


# Add a host-name to the host-database

proc do_add_host {} {
  global curr_mode curr_dir curr_file host_name do_Connect_command plmwin

  set items [listbox_selection]
  set active [listbox_active]
  if ![file writable $curr_dir/$curr_file] \
     {log_entry "Can't write to $curr_dir/$curr_file" ; return 0}
#.clear listbox-selections
  set old_hosts {}
  set len [$plmwin.display.listbox size]
  for {set i 0} {$i < $len} {incr i} {
    lappend old_hosts [$plmwin.display.listbox get $i]
  }
  set changes 0
  set host_name ""
  $plmwin.button.update invoke
#.is it a new name ?
  if {![interact entry Enter host_name] && "$host_name" != "" && \
      [lsearch -exact $old_hosts $host_name] < 0} {
#...determine path of corresponding script
    foreach i $do_Connect_command {
      if {[string first "\$f" "$i"] >= 0} {
        set f $host_name
        set path [eval list $i]
        if [file readable $path] {
          $plmwin.display.listbox insert end $host_name
          save_file
          set changes 1
        } else {
          log_entry "Can't read file $path"
        }
        break
      }
    }
  }
  do_mmail_mod $curr_mode
  if !$changes {listbox_restore $items $active}
}

