# ------------------------------------------------------------------------------
# Create a new toplevel window (loosely based on XTeXShell)
# ------------------------------------------------------------------------------
# parameters:
#   wname          - basename for new window
#   $($wname_name) - name of toplevel window
#   $($wname_geo)  - geometry of toplevel window
# return value     : Name of window on success,
#                    "" if operation was not completed
# ------------------------------------------------------------------------------

proc create_topwin {wname} {

#.Get the real window names
  set win_name "$wname\_name"
  set win_geo  "$wname\_geo"

  global $win_name $win_geo
                
  eval set win_name "\$$win_name"
  eval set win_geo  "\$$win_geo"

#.Check if window exists
  if {[info exists win_name] && [winfo exists $win_name]} {return ""}

#.Ok, we can create the new window. Get size of main window
  if {[string compare "." $win_name]} { 
    catch     {destroy $win_name}
    toplevel  $win_name
    set       geo [winfo geometry "."];
  } else {
    set       geo "10x10+0+0"
  }       
#.calculate geometry relative to main window
  if {[string first "x" $geo] >= 0} {
    set tmp [lrange [split $geo "+"] 1 end]
  } else {
    set tmp [split $geo "+"]
  }
  set mxpos [lindex $tmp 0]
  set mypos [lindex $tmp 1]

#.get geometry of new window
  set geo "$win_geo";
  if {[string first "x" $geo] >= 0} {
    set tmp [lrange [split $geo "+"] 1 end]
  } else {
    set tmp [split $geo "+"]
  }
  set nxpos [lindex $tmp 0]
  set nypos [lindex $tmp 1]
  if {[string first "x" $geo] >= 0} {
    set tmp [join $tmp]
  } else {
    set tmp ""
  }
  if {![string compare $nypos ""]} {
    set geo $tmp 
  } else { 
    set geo [format "%s+%d+%d" $tmp [expr $mxpos+$nxpos] [expr $mypos+$nypos]]
  }
  wm geometry $win_name $geo

  return $win_name
}
