/* DO NOT EDIT! 
** This file has been automatically generated from "et41.c" */
#ifdef __cplusplus
#  define EXTERN extern "C"
#else
#  define EXTERN extern
#endif
EXTERN int Et_Eval(const char *,int,const char*,...);
EXTERN int Et_EvalInt(const char *,int,const char*,...);
EXTERN char *Et_EvalString(const char *,int,const char*,...);
EXTERN double Et_EvalDouble(const char *,int,const char*,...);
EXTERN void Et_EvalInclude(const char *,char *);
EXTERN void Et_Init(int *, char **);
EXTERN void Et_MainLoop(void);
EXTERN void Et_ReadStdin(void);
EXTERN struct Tcl_Interp *Et_Interp;
EXTERN struct Tk_Window_ *Et_MainWindow;
EXTERN struct _XDisplay *Et_Display;
#define ET_OK 0
#define ET_ERROR 1
#undef EXTERN
#define UNIX 1
#define WIN32 0
#line 1 "et41.c"
/* IMPORTANT: Read the comment below on how to compile this file.  It
 * is NOT sufficient to just hand it to the C compiler.  It must first
 * be preprocessed.
 */
/* 
 * This file has been generated by 
 *
 *                 D. Richard Hipp
 *                 drh@world.std.com
 *
 * The contributions of Dr. Hipp are placed in the public domain.  However,
 * portions of this file are subject to the copyrights shown below.
 *
 * The changes necessary to use TclX are by Michael Schumacher at
 * mike@hightec.saarlink.de.
 *
 * Copyright (c) 1990-1993 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */
/*
**
** The function Et_Eval() is an extension of Tcl_VarEval().
**
** The first and second arguments are the name of the file which
** contains the call to Et_Eval() and the line number within that
** file from which Et_Eval() was called.  This information is used
** to print an error message to stderr if necessary.
**
** The third argument is a format string built from three characters:
** 's', 'd', and 'f'.  This format string determines the number and
** type of subsequent arguments.  Each 's' in the format string
** corresponds to a string argument, each 'd' cooresponds to an integer,
** and each 'f' corresponds to a double.
**
** A format string may now also contain a 'q' character.  'q' means that
** the any of the characters which have special meaning to the Tcl
** interpreter (any of  "{", "}", "[", "\"", "\\" or "$") are escaped.
**
** The operation of Et_Eval() is to concatenate all arguments and
** send the result to Tcl_GlobalEval().  The return of Tcl_GlobalEval()
** is returned from Et_Eval().
**
** In addition to Et_Eval(), this file defines three other functions:
**
**      Et_EvalInt()
**      Et_EvalString()
**      Et_EvalDouble()
**
** In each of these other functions, the value returned is not the status
** string from Tcl_VarEval(), but rather the result string.  The result
** string is converted to an integer or a double for Et_EvalInt() and
** Et_EvalDouble(), respectively.
**
**      Et_EvalInclude()
**
** This function is used to implement the ET_INCLUDE() macro of the ET
** system.  It takes two arguments which are the name of a file and 
** null-terminated string containing the contents of that file.  The
** the function simply calls Tcl_GlobalEval on the string, and then prints
** an appropriate error message if something goes wrong.
**
** The Tcl/Tk interpreter used by all these functions is obtained from
** the global variable "Tcl_Interp *Et_Interp;".  This variable
** should be set to a valid interpreter before calling any function
** in this file.
**
** The function Et_InstallCmd() creates a new command for the
** Tcl/Tk interpreter pointed to by the global variable Et_Interp.
** This function was added in support of the ET_INSTALL_COMMANDS macro.
**
** All of the above functions are normally called from ET macros, not
** directly by the user.  The next set of functions are called directly
** by the user:
**
**     Et_Init(int *,char **);
**     Et_ReadStdin(void);
**     Et_MainLoop(void);
**
** The Et_Init() function should be the first function called from within
** the main() procedure of an application.  This function initializes the
** ET interpreter.  Command line arguments used by the interpreter are
** removed from  argc and argv.
**
** Et_MainLoop() should be the last function in the main() procedure.  It
** implements the event loop.
**
** If the function Et_ReadStdin() is called prior to Et_MainLoop(), then
** arrangements are made to read standard input and pass the results to
** the ET interpreter.
**
********************* HOW TO COMPILE THIS FILE **************************
**
** This file is mostly C code, but it is not completely C code.  It can
** not be handed to the C compiler directory, but must first be preprocessed
** using the "et2c" macro preprocessors.
**
** This version of the ET library file is for use with Tk version 4.1 and
** Tcl version 7.5.
*/
/* For K&R code compile with -DK_AND_R */
#include "tk.h"
#ifdef K_AND_R
#include <varargs.h>
#define const
#else
#include <stdarg.h>
#endif
#include <ctype.h>

/*
** Some external functions used
*/
extern void exit();
extern char *strrchr();
extern void free();
extern int atoi();
extern double atof();
extern int read();
extern int isatty();

/*
** The following variable points to the Tcl/Tk interpreter which is
** used by all functions in this file.
*/
Tcl_Interp *Et_Interp = 0;

/* The next variables are made available as a convenience to the
** ET programmer. */
Tk_Window Et_MainWindow;      /* The main window of the application */
Display *Et_Display;          /* The X11 display holding the main window */

/* This flag is TRUE if all scripts processed by ET() macros should
** be printed to standard output. This variable can only be set from
** within the debugger. */
static int et_trace_flag = 0;

/*
** This is the function which does most of the work.  All the Et_EvalXXXX()
** functions call this core to process the variable-length argument list,
** and then do different things with the return parameter
*/
static int
Et_VaEval(fileName,lineNumber,format,ap)
const char *fileName;      /* Name of the file containing the ET macro */
int lineNumber;            /* Line number of start of ET macro */
const char *format;        /* Format string */
va_list ap;                /* Pointer to the argument list */
{
  int i;                     /* Loop counter */
  int retc;                  /* Return code from Tcl_Eval() */
  char *buf;                 /* Buffer to hold the Tcl command string  */
  char *cp;                  /* For scanning strings */
  char c;                    /* Next character being scanned */
  char *next;                /* Pointer to the next unused slot in buf[] */
  int spaceNeeded;           /* Amount of spaced needed in buf to hold
                             ** the entire Tcl command string */
  va_list firstArg;          /* A pointer to the first argument of the
                             ** variant part of the argument list. */
  char smallSpace[40];       /* A space large enough to hold the ascii
                             ** value of an integer or floating point number */
  char bigSpace[1000];       /* The initial buffer.  Hopefully this is enough,
                             ** but if not we can malloc() for more */

  if( Et_Interp==0 ){
    fprintf(stderr,
      "ERROR: %s line %d: Et_Interp does not point to a valid Tk interpreter\n",
      fileName,lineNumber);
    return TCL_ERROR;
  }

  /* Make a pass thru the argument list and tally up the size of the
  ** buffer needed */
  firstArg = ap;
  spaceNeeded = 1;   /* One for the null-terminator */
  for(i=0; format[i]; i++){
    switch( format[i] ){
      case 's':    /* A string */
        spaceNeeded += strlen(va_arg(ap,char*));
        break;

      case 'd':    /* An integer */
        spaceNeeded += 20;
        (void)va_arg(ap,int);
        break;

      case 'f':    /* A double */
        spaceNeeded += 20;
        (void)va_arg(ap,double);
        break;

      case 'q':    /* A quoted string */
        cp = va_arg(ap,char*);
        while( (c=*cp++)!=0 ){
          if( c=='$' || c=='[' || c=='\"' || c=='\\' || c=='{' || c=='}' ){
            spaceNeeded++;
          }
          spaceNeeded++;
	}
        break;
    }
  }

  /* Get a buf which is large enough to hold it all */
  if( spaceNeeded<=sizeof(bigSpace) ){
    buf = bigSpace;
  }else{
    extern char *malloc();
    buf = malloc( spaceNeeded );
    if( buf==0 ){
       sprintf(bigSpace,"File %s line %d: can't allocate %d bytes of memory",
          fileName,lineNumber,spaceNeeded);
       Tcl_AppendResult(Et_Interp,bigSpace,0);
       return TCL_ERROR;
    }
  }

  /* Now make another pass thru the argument list in order to
  ** build the Tcl command string */
  ap = firstArg;
  next = buf;
  for(i=0; format[i]; i++){
    char *str;       /* Pointer to a source string which is to be
                     ** copied into buf */
    switch( format[i] ){
      case 's':    /* A string */
        str = va_arg(ap,char*);
        break;

      case 'd':    /* An integer */
        str = smallSpace;
        sprintf(str,"%d",va_arg(ap,int));
        break;

      case 'f':    /* A double */
        str = smallSpace;
        sprintf(str,"%g",va_arg(ap,double));
        break;

      case 'q':    /* A quoted string */
        str = va_arg(ap,char*);
        while( (c=*str)!=0 ){
          if( c=='$' || c=='[' || c=='\"' || c=='\\' || c=='{' || c=='}' ){
            *next++ = '\\';
	  }
          *next++ = c;
          str++;
	}
        break;

      default:     /* Can't happen */
        str = "";
        break;
    }
    while( (*next++ = *str++)!=0 );
    next--;
  }

  /* Evaluate the Tcl command string.  Generate an error message
  ** if an error occurs */
  retc = Tcl_GlobalEval(Et_Interp,buf);
  if( et_trace_flag ){
    char *cp = buf;
    while( *cp ){
      if( *cp=='\\' && cp[1]=='\n' ){ *cp=' '; cp[1]=' '; }
      cp++;
    }
    printf("%s\n",buf);
  }
  if( retc==TCL_ERROR ){
    char buf[40];
    fprintf(stderr,"ERROR at %s line %d: %s\n",
       fileName,Et_Interp->errorLine + lineNumber - 1,Et_Interp->result);
    sprintf(buf,"%d",Et_Interp->errorLine + lineNumber + 1);
    Tcl_VarEval(Et_Interp,"tkerror {",fileName," line ",buf,"}",0);
  }

  /* clean up and return */
  if( buf!=bigSpace ) free(buf);
  return retc;
}

/*
** This version of Et_Eval() evaluates a single string as the Tcl command,
** just as Tcl_Eval() would.  The difference is in the processing of
** error message.  This function is called by the ET_INCLUDE() macro.
** Et_Eval() could have been used, but this version avoids an extra
** copy of the script from one buffer into another.
*/
void
Et_EvalInclude(zFilename,script)
const char *zFilename; /* The file from which the script was origanally taken */
char *script;          /* The Tcl/Tk command script */
{
  if( Et_Interp==0 ){
    fprintf(stderr,
      "ERROR: %s: Et_Interp does not point to a valid Tk interpreter\n",
      zFilename);
    return;
  }
  if( Tcl_GlobalEval(Et_Interp,script)==TCL_ERROR ){
    char buf[40];
    fprintf(stderr,"ERROR at %s line %d: %s\n",
       zFilename,Et_Interp->errorLine,Et_Interp->result);
    sprintf(buf,"%d",Et_Interp->errorLine);
    Tcl_VarEval(Et_Interp,"tkerror {",zFilename," line ",buf,"}",0);
  }
}

/*
** Execute the Tcl/Tk command string and return an status code
*/
#ifdef K_AND_R
int
Et_Eval(va_alist)
va_dcl
{
  va_list ap;                /* Pointer to the argument list */
  int retc;                  /* The Tcl_Eval() return code */
  char *filename;            /* The filename */
  int lineNumber;            /* The line number */
  char *format;              /* The format string */

  va_start(ap);
  filename = va_arg(ap,char*);
  lineNumber = va_arg(ap,int);
  format = va_arg(ap,char*);
  retc = Et_VaEval(filename,lineNumber,format,ap);
  va_end(ap);
  return retc;
}
#else
int Et_Eval(const char *filename, int lineNumber, const char *format, ...){
  va_list ap;
  int retc;
  va_start(ap,format);
  retc = Et_VaEval(filename,lineNumber,format,ap);
  va_end(ap);
  return retc;
}
#endif

/*
** Execute the Tcl/Tk command string and return the result string
*/
#ifdef K_AND_R
char *
Et_EvalString(va_alist)
va_dcl
{
  va_list ap;                /* Pointer to the argument list */
  int status;                /* The status returned from Et_VaEval() */
  char *filename;            /* The filename */
  int lineNumber;            /* The line number */
  char *format;              /* The format string */

  va_start(ap);
  filename = va_arg(ap,char*);
  lineNumber = va_arg(ap,int);
  format = va_arg(ap,char*);
  status = Et_VaEval(filename,lineNumber,format,ap);
  va_end(ap);
  return Et_Interp->result;
}
#else
char *
Et_EvalString(const char *filename, int lineNumber, const char *format, ...){
  va_list ap;
  int status;
  va_start(ap,format);
  status = Et_VaEval(filename,lineNumber,format,ap);
  va_end(ap);
  return Et_Interp->result;
}
#endif

/*
** Execute the Tcl/Tk command string and return the result converted
** into an integer
*/
#ifdef K_AND_R
int
Et_EvalInt(va_alist)
va_dcl
{
  va_list ap;                /* Pointer to the argument list */
  int status;                /* The status returned from Et_VaEval() */
  char *filename;            /* The filename */
  int lineNumber;            /* The line number */
  char *format;              /* The format string */

  va_start(ap);
  filename = va_arg(ap,char*);
  lineNumber = va_arg(ap,int);
  format = va_arg(ap,char*);
  status = Et_VaEval(filename,lineNumber,format,ap);
  va_end(ap);
  return atoi(Et_Interp->result);
}
#else
int
Et_EvalInt(const char *filename, int lineNumber, const char *format, ...){
  va_list ap;
  int status;
  va_start(ap,format);
  status = Et_VaEval(filename,lineNumber,format,ap);
  va_end(ap);
  return atoi(Et_Interp->result);
}
#endif

/*
** Execute the Tcl/Tk command string and return the result converted
** into an double
*/
#ifdef K_AND_R
double
Et_EvalDouble(va_alist)
va_dcl
{
  va_list ap;                /* Pointer to the argument list */
  int status;                /* The status returned from Et_VaEval() */

  va_start(ap);
  status = Et_VaEval(ap);
  va_end(ap);
  return atof(Et_Interp->result);
}
#else
double
Et_EvalDouble(const char *filename, int lineNumber, const char *format, ...){
  va_list ap;
  int status;
  va_start(ap,format);
  status = Et_VaEval(filename,lineNumber,format,ap);
  va_end(ap);
  return atof(Et_Interp->result);
}
#endif

/*
** Install a new command into the interpreter.
*/
#ifdef K_AND_R
void
Et_InstallCommand(zName,cmdProc)
char *zName;         /* Name of the command */
int (*cmdProc)();    /* Procedure which implements the command */
{
  Tcl_CreateCommand(Et_Interp,zName,cmdProc,Tk_MainWindow(Et_Interp),0);
}
#else
void
Et_InstallCommand(
  char *zName, 
  int (*cmdProc)(void*,struct Tcl_Interp*,int,char**)
){
  Tcl_CreateCommand(Et_Interp,zName,cmdProc,Tk_MainWindow(Et_Interp),0);
}
#endif

/*
** Initialize the Tcl/Tk interpreter.
**
** This is a highly modified version of "main()" from the
** file "tkMain.c" in the standard Tcl/Tk distribution.
*/
void
Et_Init(pargc,argv)
int *pargc;
char **argv;
{
    char *args;

    if( getenv("DISPLAY")==0 ){
      fprintf(stderr,"%s: DISPLAY environment variable is not set.\n",argv[0]);
      exit(1);
    }
    Tcl_FindExecutable(argv[0]);
    Et_Interp = Tcl_CreateInterp();

    /*
     * Make command-line arguments available in the Tcl variables "argc"
     * and "argv".
     */

    args = Tcl_Merge(*pargc-1, argv+1);
    Tcl_SetVar(Et_Interp, "argv", args, TCL_GLOBAL_ONLY);
    ckfree(args);
    Et_Eval(__FILE__,__LINE__,"sds","set argc ",(*pargc-1)," ");
    Et_Eval(__FILE__,__LINE__,"sqs","set argv0 \"",(argv[0]),"\" ");

    /*
     * Set the "tcl_interactive" variable.
     */
    Et_Eval(__FILE__,__LINE__,"sds","set tcl_interactive ",(isatty(0))," ");

    /*
     * Invoke application-specific initialization.
     */
    Tk_Init(Et_Interp);
    Tcl_StaticPackage(Et_Interp, "Tk", Tk_Init, (Tcl_PackageInitProc *) NULL);

    /* Set the et_trace_flag */
    Tcl_LinkVar(Et_Interp, "et_trace_flag", (char*)&et_trace_flag,TCL_LINK_INT);

    /* Set up some convenience global variables.
    **
    ** This only works if there is a single display and screen.  But, then
    ** again, ET only works with a single screen...
    */
    Et_MainWindow = Tk_MainWindow(Et_Interp);
    Et_Display = Tk_Display(Et_MainWindow);

    /*
     * Create variables "cmd_name" and "cmd_dir" which contain the
     * base name of the application and the name of the directory 
     * which contains the executable for the application.
     */
    Et_Eval(__FILE__,__LINE__,"sssssssssss","\n"
,"set cmd_name [file tail $argv0]\n"
,"set cmd_dir [file dirname $argv0]\n"
,"if \"![file readable $argv0] || ![file isfile $argv0]\" {\n"
,"foreach i [split $env(PATH) :] {\n"
,"if \"[file readable $i/$cmd_name] && [file isfile $i/$cmd_name]\" {\n"
,"set cmd_dir $i\n"
,"break;\n"
,"}\n"
,"}\n"
,"}\n"
);
}

/* Platform-specific initialization
*/
int TkPlatformInit(interp)
  Tcl_Interp *interp;
{ 
  extern void TkCreateXEventSource();
  TkCreateXEventSource();

 /* Load the Tcl/Tk startup scripts.
  */
  Et_Eval(__FILE__,__LINE__,"s","set tk_library {}; set tcl_library {} ");
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if {[info commands package] == \"\"} {\n"
"error \"version mismatch: library\\nscripts expect Tcl version 7.5b1 or later but the loaded version is\\nonly [info patchlevel]\"\n"
"}\n"
"package require -exact Tcl 7.5\n"
"if [catch {set auto_path $env(TCLLIBPATH)}] {\n"
"set auto_path \"\"\n"
"}\n"
"if {[lsearch -exact $auto_path [info library]] < 0} {\n"
"lappend auto_path [info library]\n"
"}\n"
"package unknown tclPkgUnknown\n"
"if {[info commands exec] == \"\"} {\n"
"\n"
"set auto_noexec 1\n"
"}\n"
"set errorCode \"\"\n"
"set errorInfo \"\"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc unknown args {\n"
"global auto_noexec auto_noload env unknown_pending tcl_interactive\n"
"global errorCode errorInfo\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"set savedErrorCode $errorCode\n"
"set savedErrorInfo $errorInfo\n"
"set name [lindex $args 0]\n"
"if ![info exists auto_noload] {\n"
"\n"
"\n"
"\n"
"if [info exists unknown_pending($name)] {\n"
"unset unknown_pending($name)\n"
"if {[array size unknown_pending] == 0} {\n"
"unset unknown_pending\n"
"}\n"
"return -code error \"self-referential recursion in \\\"unknown\\\" for command \\\"$name\\\"\";\n"
"}\n"
"set unknown_pending($name) pending;\n"
"set ret [catch {auto_load $name} msg]\n"
"unset unknown_pending($name);\n"
"if {$ret != 0} {\n"
"return -code $ret -errorcode $errorCode \\\n"
"\"error while autoloading \\\"$name\\\": $msg\"\n"
"}\n"
"if ![array size unknown_pending] {\n"
"unset unknown_pending\n"
"}\n"
"if $msg {\n"
"set errorCode $savedErrorCode\n"
"set errorInfo $savedErrorInfo\n"
"set code [catch {uplevel $args} msg]\n"
"if {$code ==  1} {\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"set new [split $errorInfo \\n]\n"
"set new [join [lrange $new 0 [expr [llength $new] - 6]] \\n]\n"
"return -code error -errorcode $errorCode \\\n"
"-errorinfo $new $msg\n"
"} else {\n"
"return -code $code $msg\n"
"}\n"
"}\n"
"}\n"
"if {([info level] == 1) && ([info script] == \"\") \\\n"
"&& [info exists tcl_interactive] && $tcl_interactive} {\n"
"if ![info exists auto_noexec] {\n"
"if [auto_execok $name] {\n"
"set errorCode $savedErrorCode\n"
"set errorInfo $savedErrorInfo\n"
"return [uplevel exec >&@stdout <@stdin $args]\n"
"}\n"
"}\n"
"set errorCode $savedErrorCode\n"
"set errorInfo $savedErrorInfo\n"
"if {$name == \"!!\"} {\n"
"return [uplevel {history redo}]\n"
"}\n"
"if [regexp {^!(.+)$} $name dummy event] {\n"
"return [uplevel [list history redo $event]]\n"
"}\n"
"if [regexp {^\\^([^^]*)\\^([^^]*)\\^?$} $name dummy old new] {\n"
"return [uplevel [list history substitute $old $new]]\n"
"}\n"
"set cmds [info commands $name*]\n"
"if {[llength $cmds] == 1} {\n"
"return [uplevel [lreplace $args 0 0 $cmds]]\n"
"}\n"
"if {[llength $cmds] != 0} {\n"
"if {$name == \"\"} {\n"
"return -code error \"empty command name \\\"\\\"\"\n"
"} else {\n"
"return -code error \\\n"
"\"ambiguous command name \\\"$name\\\": [lsort $cmds]\"\n"
"}\n"
"}\n"
"}\n"
"return -code error \"invalid command name \\\"$name\\\"\"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc auto_load cmd {\n"
"global auto_index auto_oldpath auto_path env errorInfo errorCode\n"
"\n"
"if [info exists auto_index($cmd)] {\n"
"uplevel #0 $auto_index($cmd)\n"
"return [expr {[info commands $cmd] != \"\"}]\n"
"}\n"
"if ![info exists auto_path] {\n"
"return 0\n"
"}\n"
"if [info exists auto_oldpath] {\n"
"if {$auto_oldpath == $auto_path} {\n"
"return 0\n"
"}\n"
"}\n"
"set auto_oldpath $auto_path\n"
"for {set i [expr [llength $auto_path] - 1]} {$i >= 0} {incr i -1} {\n"
"set dir [lindex $auto_path $i]\n"
"set f \"\"\n"
"if [catch {set f [open [file join $dir tclIndex]]}] {\n"
"continue\n"
"}\n"
"set error [catch {\n"
"set id [gets $f]\n"
"if {$id == \"# Tcl autoload index file, version 2.0\"} {\n"
"eval [read $f]\n"
"} elseif {$id == \"# Tcl autoload index file: each line identifies a Tcl\"} {\n"
"while {[gets $f line] >= 0} {\n"
"if {([string index $line 0] == \"#\")\n"
"|| ([llength $line] != 2)} {\n"
"continue\n"
"}\n"
"set name [lindex $line 0]\n"
"set auto_index($name) \\\n"
"\"source [file join $dir [lindex $line 1]]\"\n"
"}\n"
"} else {\n"
"error \"[file join $dir tclIndex] isn't a proper Tcl index file\"\n"
"}\n"
"} msg]\n"
"if {$f != \"\"} {\n"
"close $f\n"
"}\n"
"if $error {\n"
"error $msg $errorInfo $errorCode\n"
"}\n"
"}\n"
"if [info exists auto_index($cmd)] {\n"
"uplevel #0 $auto_index($cmd)\n"
"if {[info commands $cmd] != \"\"} {\n"
"return 1\n"
"}\n"
"}\n"
"return 0\n"
"}\n"
"\n"
"if {[string compare $tcl_platform(platform) windows] == 0} {\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc auto_execok name {\n"
"global auto_execs env\n"
"\n"
"if [info exists auto_execs($name)] {\n"
"return $auto_execs($name)\n"
"}\n"
"set auto_execs($name) 0\n"
"if {[file pathtype $name] != \"relative\"} {\n"
"foreach ext {.exe .bat .cmd} {\n"
"if {[file exists ${name}${ext}]\n"
"&& ![file isdirectory ${name}${ext}]} {\n"
"set auto_execs($name) 1\n"
"}\n"
"}\n"
"return $auto_execs($name)\n"
"}\n"
"if {! [info exists env(PATH)]} {\n"
"if [info exists env(Path)] {\n"
"set path $env(Path)\n"
"} else {\n"
"return 0\n"
"}\n"
"} else {\n"
"set path $env(PATH)\n"
"}\n"
"foreach dir [split $path {;}] {\n"
"if {$dir == \"\"} {\n"
"set dir .\n"
"}\n"
"foreach ext {.exe .bat .cmd} {\n"
"set file [file join $dir ${name}${ext}]\n"
"if {[file exists $file] && ![file isdirectory $file]} {\n"
"set auto_execs($name) 1\n"
"return 1\n"
"}\n"
"}\n"
"}\n"
"return 0\n"
"}\n"
"\n"
"} else {\n"
"\n"
"\n"
"\n"
"proc auto_execok name {\n"
"global auto_execs env\n"
"\n"
"if [info exists auto_execs($name)] {\n"
"return $auto_execs($name)\n"
"}\n"
"set auto_execs($name) 0\n"
"if {[file pathtype $name] != \"relative\"} {\n"
"if {[file executable $name] && ![file isdirectory $name]} {\n"
"set auto_execs($name) 1\n"
"}\n"
"return $auto_execs($name)\n"
"}\n"
"foreach dir [split $env(PATH) :] {\n"
"if {$dir == \"\"} {\n"
"set dir .\n"
"}\n"
"set file [file join $dir $name]\n"
"if {[file executable $file] && ![file isdirectory $file]} {\n"
"set auto_execs($name) 1\n"
"return 1\n"
"}\n"
"}\n"
"return 0\n"
"}\n"
"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc auto_reset {} {\n"
"global auto_execs auto_index auto_oldpath\n"
"foreach p [info procs] {\n"
"if {[info exists auto_index($p)] && ($p != \"unknown\")\n"
"&& ![string match auto_* $p]} {\n"
"rename $p {}\n"
"}\n"
"}\n"
"catch {unset auto_execs}\n"
"catch {unset auto_index}\n"
"catch {unset auto_oldpath}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc auto_mkindex {dir args} {\n"
"global errorCode errorInfo\n"
"set oldDir [pwd]\n"
"cd $dir\n"
"set dir [pwd]\n"
"append index \"# Tcl autoload index file, version 2.0\\n\"\n"
"append index \"# This file is generated by the \\\"auto_mkindex\\\" command\\n\"\n"
"append index \"# and sourced to set up indexing information for one or\\n\"\n"
"append index \"# more commands.  Typically each line is a command that\\n\"\n"
"append index \"# sets an element in the auto_index array, where the\\n\"\n"
"append index \"# element name is the name of a command and the value is\\n\"\n"
"append index \"# a script that loads the command.\\n\\n\"\n"
"if {$args == \"\"} {\n"
"set args *.tcl\n"
"}\n"
"foreach file [eval glob $args] {\n"
"set f \"\"\n"
"set error [catch {\n"
"set f [open $file]\n"
"while {[gets $f line] >= 0} {\n"
"if [regexp {^proc[  ]+([^  ]*)} $line match procName] {\n"
"append index \"set [list auto_index($procName)]\"\n"
"append index \" \\[list source \\[file join \\$dir [list $file]\\]\\]\\n\"\n"
"}\n"
"}\n"
"close $f\n"
"} msg]\n"
"if $error {\n"
"set code $errorCode\n"
"set info $errorInfo\n"
"catch {close $f}\n"
"cd $oldDir\n"
"error $msg $info $code\n"
"}\n"
"}\n"
"set f \"\"\n"
"set error [catch {\n"
"set f [open tclIndex w]\n"
"puts $f $index nonewline\n"
"close $f\n"
"cd $oldDir\n"
"} msg]\n"
"if $error {\n"
"set code $errorCode\n"
"set info $errorInfo\n"
"catch {close $f}\n"
"cd $oldDir\n"
"error $msg $info $code\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc pkg_mkIndex {dir args} {\n"
"global errorCode errorInfo\n"
"append index \"# Tcl package index file, version 1.0\\n\"\n"
"append index \"# This file is generated by the \\\"pkg_mkIndex\\\" command\\n\"\n"
"append index \"# and sourced either when an application starts up or\\n\"\n"
"append index \"# by a \\\"package unknown\\\" script.  It invokes the\\n\"\n"
"append index \"# \\\"package ifneeded\\\" command to set up package-related\\n\"\n"
"append index \"# information so that packages will be loaded automatically\\n\"\n"
"append index \"# in response to \\\"package require\\\" commands.  When this\\n\"\n"
"append index \"# script is sourced, the variable \\$dir must contain the\\n\"\n"
"append index \"# full path name of this file's directory.\\n\"\n"
"set oldDir [pwd]\n"
"cd $dir\n"
"foreach file [eval glob $args] {\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"set c [interp create]\n"
"$c eval [list set file $file]\n"
"if [catch {\n"
"$c eval {\n"
"proc dummy args {}\n"
"package unknown dummy\n"
"set origCmds [info commands]\n"
"set dir \"\"  ;# in case file is pkgIndex.tcl\n"
"set pkgs \"\"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if [catch {load [file join . $file]}] {\n"
"if [catch {source $file}] {\n"
"puts $errorInfo\n"
"error \"can't either load or source $file\"\n"
"} else {\n"
"set type source\n"
"}\n"
"} else {\n"
"set type load\n"
"}\n"
"foreach i [info commands] {\n"
"set cmds($i) 1\n"
"}\n"
"foreach i $origCmds {\n"
"catch {unset cmds($i)}\n"
"}\n"
"foreach i [package names] {\n"
"if {([string compare [package provide $i] \"\"] != 0)\n"
"&& ([string compare $i Tcl] != 0)} {\n"
"lappend pkgs [list $i [package provide $i]]\n"
"}\n"
"}\n"
"}\n"
"} msg] {\n"
"interp delete $c\n"
"error $msg $errorInfo $errorCode\n"
"}\n"
"foreach pkg [$c eval set pkgs] {\n"
"lappend files($pkg) [list $file [$c eval set type] \\\n"
"[lsort [$c eval array names cmds]]]\n"
"}\n"
"interp delete $c\n"
"}\n"
"foreach pkg [lsort [array names files]] {\n"
"append index \"\\npackage ifneeded $pkg\\\n"
"\\\"tclPkgSetup \\$dir [lrange $pkg 0 0] [lrange $pkg 1 1]\\\n"
"[list $files($pkg)]\\\"\"\n"
"}\n"
"set f [open pkgIndex.tcl w]\n"
"puts $f $index\n"
"close $f\n"
"cd $oldDir\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tclPkgSetup {dir pkg version files} {\n"
"global auto_index\n"
"\n"
"package provide $pkg $version\n"
"foreach fileInfo $files {\n"
"set f [lindex $fileInfo 0]\n"
"set type [lindex $fileInfo 1]\n"
"foreach cmd [lindex $fileInfo 2] {\n"
"if {$type == \"load\"} {\n"
"set auto_index($cmd) [list load [file join $dir $f] $pkg]\n"
"} else {\n"
"set auto_index($cmd) [list source [file join $dir $f]]\n"
"} \n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tclPkgUnknown {name version {exact {}}} {\n"
"global auto_path\n"
"\n"
"if ![info exists auto_path] {\n"
"return\n"
"}\n"
"for {set i [expr [llength $auto_path] - 1]} {$i >= 0} {incr i -1} {\n"
"set dir [lindex $auto_path $i]\n"
"set file [file join $dir pkgIndex.tcl]\n"
"if [file readable $file] {\n"
"source $file\n"
"}\n"
"}\n"
"}\n"
"";
#line 561 "et41.c"
Et_EvalInclude("init.tcl",_ET_script_); };

  /* The native "tk.tcl" file won't work in ET.  The following is a
  ** substitute. */
  Et_Eval(__FILE__,__LINE__,"ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss","\n"
,"package require -exact Tk 4.1\n"
,"package require -exact Tcl 7.5\n"
,"\n"
,"\n"
,"set tk_strictMotif 0\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"proc tkScreenChanged screen {\n"
,"set disp [file rootname $screen]\n"
,"uplevel #0 upvar #0 tkPriv.$disp tkPriv\n"
,"global tkPriv\n"
,"if [info exists tkPriv] {\n"
,"set tkPriv(screen) $screen\n"
,"return\n"
,"}\n"
,"set tkPriv(afterId) {}\n"
,"set tkPriv(buttons) 0\n"
,"set tkPriv(buttonWindow) {}\n"
,"set tkPriv(dragging) 0\n"
,"set tkPriv(focus) {}\n"
,"set tkPriv(grab) {}\n"
,"set tkPriv(initPos) {}\n"
,"set tkPriv(inMenubutton) {}\n"
,"set tkPriv(listboxPrev) {}\n"
,"set tkPriv(mouseMoved) 0\n"
,"set tkPriv(oldGrab) {}\n"
,"set tkPriv(popup) {}\n"
,"set tkPriv(postedMb) {}\n"
,"set tkPriv(pressX) 0\n"
,"set tkPriv(pressY) 0\n"
,"set tkPriv(screen) $screen\n"
,"set tkPriv(selectMode) char\n"
,"set tkPriv(window) {}\n"
,"}\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"tkScreenChanged [winfo screen .]\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"bind all <Tab> {focus [tk_focusNext %W]}\n"
,"bind all <Shift-Tab> {focus [tk_focusPrev %W]}\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"\n"
,"proc tkCancelRepeat {} {\n"
,"global tkPriv\n"
,"after cancel $tkPriv(afterId)\n"
,"set tkPriv(afterId) {}\n"
,"}\n"
);
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc bgerror err {\n"
"global errorInfo\n"
"set info $errorInfo\n"
"set button [tk_dialog .bgerrorDialog \"Error in Tcl Script\" \\\n"
"\"Error: $err\" error 0 OK \"Skip Messages\" \"Stack Trace\"]\n"
"if {$button == 0} {\n"
"return\n"
"} elseif {$button == 1} {\n"
"return -code break\n"
"}\n"
"\n"
"set w .bgerrorTrace\n"
"catch {destroy $w}\n"
"toplevel $w -class ErrorTrace\n"
"wm minsize $w 1 1\n"
"wm title $w \"Stack Trace for Error\"\n"
"wm iconname $w \"Stack Trace\"\n"
"button $w.ok -text OK -command \"destroy $w\"\n"
"text $w.text -relief sunken -bd 2 -yscrollcommand \"$w.scroll set\" \\\n"
"-setgrid true -width 60 -height 20\n"
"scrollbar $w.scroll -relief sunken -command \"$w.text yview\"\n"
"pack $w.ok -side bottom -padx 3m -pady 2m\n"
"pack $w.scroll -side right -fill y\n"
"pack $w.text -side left -expand yes -fill both\n"
"$w.text insert 0.0 $info\n"
"$w.text mark set insert 0.0\n"
"\n"
"\n"
"\n"
"wm withdraw $w\n"
"update idletasks\n"
"set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \\\n"
"- [winfo vrootx [winfo parent $w]]]\n"
"set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \\\n"
"- [winfo vrooty [winfo parent $w]]]\n"
"wm geom $w +$x+$y\n"
"wm deiconify $w\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if {[grab current .] != \"\"} {\n"
"grab release [grab current .]\n"
"}\n"
"}\n"
"";
#line 636 "et41.c"
Et_EvalInclude("bgerror.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Button <FocusIn> {}\n"
"bind Button <Enter> {\n"
"tkButtonEnter %W\n"
"}\n"
"bind Button <Leave> {\n"
"tkButtonLeave %W\n"
"}\n"
"bind Button <1> {\n"
"tkButtonDown %W\n"
"}\n"
"bind Button <ButtonRelease-1> {\n"
"tkButtonUp %W\n"
"}\n"
"bind Button <space> {\n"
"tkButtonInvoke %W\n"
"}\n"
"\n"
"bind Checkbutton <FocusIn> {}\n"
"bind Checkbutton <Enter> {\n"
"tkButtonEnter %W\n"
"}\n"
"bind Checkbutton <Leave> {\n"
"tkButtonLeave %W\n"
"}\n"
"bind Checkbutton <1> {\n"
"tkCheckRadioInvoke %W\n"
"}\n"
"bind Checkbutton <space> {\n"
"tkCheckRadioInvoke %W\n"
"}\n"
"bind Checkbutton <Return> {\n"
"if !$tk_strictMotif {\n"
"tkCheckRadioInvoke %W\n"
"}\n"
"}\n"
"\n"
"bind Radiobutton <FocusIn> {}\n"
"bind Radiobutton <Enter> {\n"
"tkButtonEnter %W\n"
"}\n"
"bind Radiobutton <Leave> {\n"
"tkButtonLeave %W\n"
"}\n"
"bind Radiobutton <1> {\n"
"tkCheckRadioInvoke %W\n"
"}\n"
"bind Radiobutton <space> {\n"
"tkCheckRadioInvoke %W\n"
"}\n"
"bind Radiobutton <Return> {\n"
"if !$tk_strictMotif {\n"
"tkCheckRadioInvoke %W\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkButtonEnter {w} {\n"
"global tkPriv\n"
"if {[$w cget -state] != \"disabled\"} {\n"
"$w config -state active\n"
"if {$tkPriv(buttonWindow) == $w} {\n"
"$w configure -state active -relief sunken\n"
"}\n"
"}\n"
"set tkPriv(window) $w\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkButtonLeave w {\n"
"global tkPriv\n"
"if {[$w cget -state] != \"disabled\"} {\n"
"$w config -state normal\n"
"}\n"
"if {$w == $tkPriv(buttonWindow)} {\n"
"$w configure -relief $tkPriv(relief)\n"
"}\n"
"set tkPriv(window) \"\"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkButtonDown w {\n"
"global tkPriv\n"
"set tkPriv(relief) [lindex [$w config -relief] 4]\n"
"if {[$w cget -state] != \"disabled\"} {\n"
"set tkPriv(buttonWindow) $w\n"
"$w config -relief sunken\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkButtonUp w {\n"
"global tkPriv\n"
"if {$w == $tkPriv(buttonWindow)} {\n"
"set tkPriv(buttonWindow) \"\"\n"
"$w config -relief $tkPriv(relief)\n"
"if {($w == $tkPriv(window))\n"
"&& ([$w cget -state] != \"disabled\")} {\n"
"uplevel #0 [list $w invoke]\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkButtonInvoke w {\n"
"if {[$w cget -state] != \"disabled\"} {\n"
"set oldRelief [$w cget -relief]\n"
"set oldState [$w cget -state]\n"
"$w configure -state active -relief sunken\n"
"update idletasks\n"
"after 100\n"
"$w configure -state $oldState -relief $oldRelief\n"
"uplevel #0 [list $w invoke]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkCheckRadioInvoke w {\n"
"if {[$w cget -state] != \"disabled\"} {\n"
"uplevel #0 [list $w invoke]\n"
"}\n"
"}\n"
"";
#line 637 "et41.c"
Et_EvalInclude("button.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_dialog {w title text bitmap default args} {\n"
"global tkPriv\n"
"\n"
"\n"
"\n"
"\n"
"catch {destroy $w}\n"
"toplevel $w -class Dialog\n"
"wm title $w $title\n"
"wm iconname $w Dialog\n"
"wm protocol $w WM_DELETE_WINDOW { }\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"frame $w.bot -relief raised -bd 1\n"
"pack $w.bot -side bottom -fill both\n"
"frame $w.top -relief raised -bd 1\n"
"pack $w.top -side top -fill both -expand 1\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"option add *Dialog.msg.wrapLength 3i widgetDefault\n"
"label $w.msg -justify left -text $text\n"
"catch {$w.msg configure -font \\\n"
"-Adobe-Times-Medium-R-Normal--*-180-*-*-*-*-*-*\n"
"}\n"
"pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m\n"
"if {$bitmap != \"\"} {\n"
"label $w.bitmap -bitmap $bitmap\n"
"pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m\n"
"}\n"
"\n"
"\n"
"\n"
"set i 0\n"
"foreach but $args {\n"
"button $w.button$i -text $but -command \"set tkPriv(button) $i\"\n"
"if {$i == $default} {\n"
"frame $w.default -relief sunken -bd 1\n"
"raise $w.button$i $w.default\n"
"pack $w.default -in $w.bot -side left -expand 1 -padx 3m -pady 2m\n"
"pack $w.button$i -in $w.default -padx 2m -pady 2m\n"
"} else {\n"
"pack $w.button$i -in $w.bot -side left -expand 1 \\\n"
"-padx 3m -pady 2m\n"
"}\n"
"incr i\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"if {$default >= 0} {\n"
"bind $w <Return> \"\n"
"$w.button$default configure -state active -relief sunken\n"
"update idletasks\n"
"after 100\n"
"set tkPriv(button) $default\n"
"\"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"wm withdraw $w\n"
"update idletasks\n"
"set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \\\n"
"- [winfo vrootx [winfo parent $w]]]\n"
"set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \\\n"
"- [winfo vrooty [winfo parent $w]]]\n"
"wm geom $w +$x+$y\n"
"wm deiconify $w\n"
"\n"
"\n"
"\n"
"set oldFocus [focus]\n"
"set oldGrab [grab current $w]\n"
"if {$oldGrab != \"\"} {\n"
"set grabStatus [grab status $oldGrab]\n"
"}\n"
"grab $w\n"
"if {$default >= 0} {\n"
"focus $w.button$default\n"
"} else {\n"
"focus $w\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"tkwait variable tkPriv(button)\n"
"catch {focus $oldFocus}\n"
"destroy $w\n"
"if {$oldGrab != \"\"} {\n"
"if {$grabStatus == \"global\"} {\n"
"grab -global $oldGrab\n"
"} else {\n"
"grab $oldGrab\n"
"}\n"
"}\n"
"return $tkPriv(button)\n"
"}\n"
"";
#line 638 "et41.c"
Et_EvalInclude("dialog.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryClipboardKeysyms {copy cut paste} {\n"
"bind Entry <$copy> {\n"
"if {[selection own -displayof %W] == \"%W\"} {\n"
"clipboard clear -displayof %W\n"
"catch {\n"
"clipboard append -displayof %W [selection get -displayof %W]\n"
"}\n"
"}\n"
"}\n"
"bind Entry <$cut> {\n"
"if {[selection own -displayof %W] == \"%W\"} {\n"
"clipboard clear -displayof %W\n"
"catch {\n"
"clipboard append -displayof %W [selection get -displayof %W]\n"
"%W delete sel.first sel.last\n"
"}\n"
"}\n"
"}\n"
"bind Entry <$paste> {\n"
"catch {\n"
"%W insert insert [selection get -displayof %W \\\n"
"-selection CLIPBOARD]\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Entry <1> {\n"
"tkEntryButton1 %W %x\n"
"%W selection clear\n"
"}\n"
"bind Entry <B1-Motion> {\n"
"set tkPriv(x) %x\n"
"tkEntryMouseSelect %W %x\n"
"}\n"
"bind Entry <Double-1> {\n"
"set tkPriv(selectMode) word\n"
"tkEntryMouseSelect %W %x\n"
"catch {%W icursor sel.first}\n"
"}\n"
"bind Entry <Triple-1> {\n"
"set tkPriv(selectMode) line\n"
"tkEntryMouseSelect %W %x\n"
"%W icursor 0\n"
"}\n"
"bind Entry <Shift-1> {\n"
"set tkPriv(selectMode) char\n"
"%W selection adjust @%x\n"
"}\n"
"bind Entry <Double-Shift-1> {\n"
"set tkPriv(selectMode) word\n"
"tkEntryMouseSelect %W %x\n"
"}\n"
"bind Entry <Triple-Shift-1> {\n"
"set tkPriv(selectMode) line\n"
"tkEntryMouseSelect %W %x\n"
"}\n"
"bind Entry <B1-Leave> {\n"
"set tkPriv(x) %x\n"
"tkEntryAutoScan %W\n"
"}\n"
"bind Entry <B1-Enter> {\n"
"tkCancelRepeat\n"
"}\n"
"bind Entry <ButtonRelease-1> {\n"
"tkCancelRepeat\n"
"}\n"
"bind Entry <Control-1> {\n"
"%W icursor @%x\n"
"}\n"
"bind Entry <ButtonRelease-2> {\n"
"if {!$tkPriv(mouseMoved) || $tk_strictMotif} {\n"
"tkEntryPaste %W %x\n"
"}\n"
"}\n"
"\n"
"bind Entry <Left> {\n"
"tkEntrySetCursor %W [expr [%W index insert] - 1]\n"
"}\n"
"bind Entry <Right> {\n"
"tkEntrySetCursor %W [expr [%W index insert] + 1]\n"
"}\n"
"bind Entry <Shift-Left> {\n"
"tkEntryKeySelect %W [expr [%W index insert] - 1]\n"
"tkEntrySeeInsert %W\n"
"}\n"
"bind Entry <Shift-Right> {\n"
"tkEntryKeySelect %W [expr [%W index insert] + 1]\n"
"tkEntrySeeInsert %W\n"
"}\n"
"bind Entry <Control-Left> {\n"
"tkEntrySetCursor %W \\\n"
"[string wordstart [%W get] [expr [%W index insert] - 1]]\n"
"}\n"
"bind Entry <Control-Right> {\n"
"tkEntrySetCursor %W [string wordend [%W get] [%W index insert]]\n"
"}\n"
"bind Entry <Shift-Control-Left> {\n"
"tkEntryKeySelect %W \\\n"
"[string wordstart [%W get] [expr [%W index insert] - 1]]\n"
"tkEntrySeeInsert %W\n"
"}\n"
"bind Entry <Shift-Control-Right> {\n"
"tkEntryKeySelect %W [string wordend [%W get] [%W index insert]]\n"
"tkEntrySeeInsert %W\n"
"}\n"
"bind Entry <Home> {\n"
"tkEntrySetCursor %W 0\n"
"}\n"
"bind Entry <Shift-Home> {\n"
"tkEntryKeySelect %W 0\n"
"tkEntrySeeInsert %W\n"
"}\n"
"bind Entry <End> {\n"
"tkEntrySetCursor %W end\n"
"}\n"
"bind Entry <Shift-End> {\n"
"tkEntryKeySelect %W end\n"
"tkEntrySeeInsert %W\n"
"}\n"
"\n"
"bind Entry <Delete> {\n"
"if [%W selection present] {\n"
"%W delete sel.first sel.last\n"
"} else {\n"
"%W delete insert\n"
"}\n"
"}\n"
"bind Entry <BackSpace> {\n"
"tkEntryBackspace %W\n"
"}\n"
"\n"
"bind Entry <Control-space> {\n"
"%W selection from insert\n"
"}\n"
"bind Entry <Select> {\n"
"%W selection from insert\n"
"}\n"
"bind Entry <Control-Shift-space> {\n"
"%W selection adjust insert\n"
"}\n"
"bind Entry <Shift-Select> {\n"
"%W selection adjust insert\n"
"}\n"
"bind Entry <Control-slash> {\n"
"%W selection range 0 end\n"
"}\n"
"bind Entry <Control-backslash> {\n"
"%W selection clear\n"
"}\n"
"tkEntryClipboardKeysyms F16 F20 F18\n"
"\n"
"bind Entry <KeyPress> {\n"
"tkEntryInsert %W %A\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Entry <Alt-KeyPress> {# nothing}\n"
"bind Entry <Meta-KeyPress> {# nothing}\n"
"bind Entry <Control-KeyPress> {# nothing}\n"
"bind Entry <Escape> {# nothing}\n"
"bind Entry <Return> {# nothing}\n"
"bind Entry <KP_Enter> {# nothing}\n"
"bind Entry <Tab> {# nothing}\n"
"\n"
"bind Entry <Insert> {\n"
"catch {tkEntryInsert %W [selection get -displayof %W]}\n"
"}\n"
"\n"
"\n"
"\n"
"bind Entry <Control-a> {\n"
"if !$tk_strictMotif {\n"
"tkEntrySetCursor %W 0\n"
"}\n"
"}\n"
"bind Entry <Control-b> {\n"
"if !$tk_strictMotif {\n"
"tkEntrySetCursor %W [expr [%W index insert] - 1]\n"
"}\n"
"}\n"
"bind Entry <Control-d> {\n"
"if !$tk_strictMotif {\n"
"%W delete insert\n"
"}\n"
"}\n"
"bind Entry <Control-e> {\n"
"if !$tk_strictMotif {\n"
"tkEntrySetCursor %W end\n"
"}\n"
"}\n"
"bind Entry <Control-f> {\n"
"if !$tk_strictMotif {\n"
"tkEntrySetCursor %W [expr [%W index insert] + 1]\n"
"}\n"
"}\n"
"bind Entry <Control-h> {\n"
"if !$tk_strictMotif {\n"
"tkEntryBackspace %W\n"
"}\n"
"}\n"
"bind Entry <Control-k> {\n"
"if !$tk_strictMotif {\n"
"%W delete insert end\n"
"}\n"
"}\n"
"bind Entry <Control-t> {\n"
"if !$tk_strictMotif {\n"
"tkEntryTranspose %W\n"
"}\n"
"}\n"
"bind Entry <Meta-b> {\n"
"if !$tk_strictMotif {\n"
"tkEntrySetCursor %W \\\n"
"[string wordstart [%W get] [expr [%W index insert] - 1]]\n"
"}\n"
"}\n"
"bind Entry <Meta-d> {\n"
"if !$tk_strictMotif {\n"
"%W delete insert [string wordend [%W get] [%W index insert]]\n"
"}\n"
"}\n"
"bind Entry <Meta-f> {\n"
"if !$tk_strictMotif {\n"
"tkEntrySetCursor %W [string wordend [%W get] [%W index insert]]\n"
"}\n"
"}\n"
"bind Entry <Meta-BackSpace> {\n"
"if !$tk_strictMotif {\n"
"%W delete [string wordstart [%W get] [expr [%W index insert] - 1]] \\\n"
"insert\n"
"}\n"
"}\n"
"if !$tk_strictMotif {\n"
"tkEntryClipboardKeysyms Meta-w Control-w Control-y\n"
"}\n"
"\n"
"\n"
"\n"
"bind Entry <2> {\n"
"if !$tk_strictMotif {\n"
"%W scan mark %x\n"
"set tkPriv(x) %x\n"
"set tkPriv(y) %y\n"
"set tkPriv(mouseMoved) 0\n"
"}\n"
"}\n"
"bind Entry <B2-Motion> {\n"
"if !$tk_strictMotif {\n"
"if {abs(%x-$tkPriv(x)) > 2} {\n"
"set tkPriv(mouseMoved) 1\n"
"}\n"
"%W scan dragto %x\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryClosestGap {w x} {\n"
"set pos [$w index @$x]\n"
"set bbox [$w bbox $pos]\n"
"if {($x - [lindex $bbox 0]) < ([lindex $bbox 2]/2)} {\n"
"return $pos\n"
"}\n"
"incr pos\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryButton1 {w x} {\n"
"global tkPriv\n"
"\n"
"set tkPriv(selectMode) char\n"
"set tkPriv(mouseMoved) 0\n"
"set tkPriv(pressX) $x\n"
"$w icursor [tkEntryClosestGap $w $x]\n"
"$w selection from insert\n"
"if {[lindex [$w configure -state] 4] == \"normal\"} {focus $w}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryMouseSelect {w x} {\n"
"global tkPriv\n"
"\n"
"set cur [tkEntryClosestGap $w $x]\n"
"set anchor [$w index anchor]\n"
"if {($cur != $anchor) || (abs($tkPriv(pressX) - $x) >= 3)} {\n"
"set tkPriv(mouseMoved) 1\n"
"}\n"
"switch $tkPriv(selectMode) {\n"
"char {\n"
"if $tkPriv(mouseMoved) {\n"
"if {$cur < $anchor} {\n"
"$w selection range $cur $anchor\n"
"} elseif {$cur > $anchor} {\n"
"$w selection range $anchor $cur\n"
"} else {\n"
"$w selection clear\n"
"}\n"
"}\n"
"}\n"
"word {\n"
"if {$cur < [$w index anchor]} {\n"
"$w selection range [string wordstart [$w get] $cur] \\\n"
"[string wordend [$w get] [expr $anchor-1]]\n"
"} else {\n"
"$w selection range [string wordstart [$w get] $anchor] \\\n"
"[string wordend [$w get] [expr $cur - 1]]\n"
"}\n"
"}\n"
"line {\n"
"$w selection range 0 end\n"
"}\n"
"}\n"
"update idletasks\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryPaste {w x} {\n"
"global tkPriv\n"
"\n"
"$w icursor [tkEntryClosestGap $w $x]\n"
"catch {$w insert insert [selection get -displayof $w]}\n"
"if {[lindex [$w configure -state] 4] == \"normal\"} {focus $w}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryAutoScan {w} {\n"
"global tkPriv\n"
"set x $tkPriv(x)\n"
"if {![winfo exists $w]} return\n"
"if {$x >= [winfo width $w]} {\n"
"$w xview scroll 2 units\n"
"tkEntryMouseSelect $w $x\n"
"} elseif {$x < 0} {\n"
"$w xview scroll -2 units\n"
"tkEntryMouseSelect $w $x\n"
"}\n"
"set tkPriv(afterId) [after 50 tkEntryAutoScan $w]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryKeySelect {w new} {\n"
"if ![$w selection present] {\n"
"$w selection from insert\n"
"$w selection to $new\n"
"} else {\n"
"$w selection adjust $new\n"
"}\n"
"$w icursor $new\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryInsert {w s} {\n"
"if {$s == \"\"} {\n"
"return\n"
"}\n"
"catch {\n"
"set insert [$w index insert]\n"
"if {([$w index sel.first] <= $insert)\n"
"&& ([$w index sel.last] >= $insert)} {\n"
"$w delete sel.first sel.last\n"
"}\n"
"}\n"
"$w insert insert $s\n"
"tkEntrySeeInsert $w\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryBackspace w {\n"
"if [$w selection present] {\n"
"$w delete sel.first sel.last\n"
"} else {\n"
"set x [expr {[$w index insert] - 1}]\n"
"if {$x >= 0} {$w delete $x}\n"
"if {[$w index @0] >= [$w index insert]} {\n"
"set range [$w xview]\n"
"set left [lindex $range 0]\n"
"set right [lindex $range 1]\n"
"$w xview moveto [expr $left - ($right - $left)/2.0]\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntrySeeInsert w {\n"
"set c [$w index insert]\n"
"set left [$w index @0]\n"
"if {$left > $c} {\n"
"$w xview $c\n"
"return\n"
"}\n"
"set x [winfo width $w]\n"
"while {([$w index @$x] <= $c) && ($left < $c)} {\n"
"incr left\n"
"$w xview $left\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntrySetCursor {w pos} {\n"
"$w icursor $pos\n"
"$w selection clear\n"
"tkEntrySeeInsert $w\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkEntryTranspose w {\n"
"set i [$w index insert]\n"
"if {$i < [$w index end]} {\n"
"incr i\n"
"}\n"
"set first [expr $i-2]\n"
"if {$first < 0} {\n"
"return\n"
"}\n"
"set new [string index [$w get] [expr $i-1]][string index [$w get] $first]\n"
"$w delete $first $i\n"
"$w insert insert $new\n"
"tkEntrySeeInsert $w\n"
"}\n"
"";
#line 639 "et41.c"
Et_EvalInclude("entry.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_focusNext w {\n"
"set cur $w\n"
"while 1 {\n"
"\n"
"\n"
"\n"
"set parent $cur\n"
"set children [winfo children $cur]\n"
"set i -1\n"
"\n"
"\n"
"\n"
"while 1 {\n"
"incr i\n"
"if {$i < [llength $children]} {\n"
"set cur [lindex $children $i]\n"
"if {[winfo toplevel $cur] == $cur} {\n"
"continue\n"
"} else {\n"
"break\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"set cur $parent\n"
"if {[winfo toplevel $cur] == $cur} {\n"
"break\n"
"}\n"
"set parent [winfo parent $parent]\n"
"set children [winfo children $parent]\n"
"set i [lsearch -exact $children $cur]\n"
"}\n"
"if {($cur == $w) || [tkFocusOK $cur]} {\n"
"return $cur\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_focusPrev w {\n"
"set cur $w\n"
"while 1 {\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if {[winfo toplevel $cur] == $cur}  {\n"
"set parent $cur\n"
"set children [winfo children $cur]\n"
"set i [llength $children]\n"
"} else {\n"
"set parent [winfo parent $cur]\n"
"set children [winfo children $parent]\n"
"set i [lsearch -exact $children $cur]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"while {$i > 0} {\n"
"incr i -1\n"
"set cur [lindex $children $i]\n"
"if {[winfo toplevel $cur] == $cur} {\n"
"continue\n"
"}\n"
"set parent $cur\n"
"set children [winfo children $parent]\n"
"set i [llength $children]\n"
"}\n"
"set cur $parent\n"
"if {($cur == $w) || [tkFocusOK $cur]} {\n"
"return $cur\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkFocusOK w {\n"
"set code [catch {$w cget -takefocus} value]\n"
"if {($code == 0) && ($value != \"\")} {\n"
"if {$value == 0} {\n"
"return 0\n"
"} elseif {$value == 1} {\n"
"return [winfo viewable $w]\n"
"} else {\n"
"set value [uplevel #0 $value $w]\n"
"if {$value != \"\"} {\n"
"return $value\n"
"}\n"
"}\n"
"}\n"
"if {![winfo viewable $w]} {\n"
"return 0\n"
"}\n"
"set code [catch {$w cget -state} value]\n"
"if {($code == 0) && ($value == \"disabled\")} {\n"
"return 0\n"
"}\n"
"regexp Key|Focus \"[bind $w] [bind [winfo class $w]]\"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_focusFollowsMouse {} {\n"
"set old [bind all <Enter>]\n"
"set script {\n"
"if {(\"%d\" == \"NotifyAncestor\") || (\"%d\" == \"NotifyNonlinear\")\n"
"|| (\"%d\" == \"NotifyInferior\")} {\n"
"if [tkFocusOK %W] {\n"
"focus %W\n"
"}\n"
"}\n"
"}\n"
"if {$old != \"\"} {\n"
"bind all <Enter> \"$old; $script\"\n"
"} else {\n"
"bind all <Enter> $script\n"
"}\n"
"}\n"
"";
#line 640 "et41.c"
Et_EvalInclude("focus.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Listbox <1> {\n"
"if [winfo exists %W] {\n"
"tkListboxBeginSelect %W [%W index @%x,%y]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Listbox <2> {\n"
"\n"
"}\n"
"\n"
"bind Listbox <B1-Motion> {\n"
"set tkPriv(x) %x\n"
"set tkPriv(y) %y\n"
"tkListboxMotion %W [%W index @%x,%y]\n"
"}\n"
"bind Listbox <ButtonRelease-1> {\n"
"tkCancelRepeat\n"
"%W activate @%x,%y\n"
"}\n"
"bind Listbox <Shift-1> {\n"
"tkListboxBeginExtend %W [%W index @%x,%y]\n"
"}\n"
"bind Listbox <Control-1> {\n"
"tkListboxBeginToggle %W [%W index @%x,%y]\n"
"}\n"
"bind Listbox <B1-Leave> {\n"
"set tkPriv(x) %x\n"
"set tkPriv(y) %y\n"
"tkListboxAutoScan %W\n"
"}\n"
"bind Listbox <B1-Enter> {\n"
"tkCancelRepeat\n"
"}\n"
"\n"
"bind Listbox <Up> {\n"
"tkListboxUpDown %W -1\n"
"}\n"
"bind Listbox <Shift-Up> {\n"
"tkListboxExtendUpDown %W -1\n"
"}\n"
"bind Listbox <Down> {\n"
"tkListboxUpDown %W 1\n"
"}\n"
"bind Listbox <Shift-Down> {\n"
"tkListboxExtendUpDown %W 1\n"
"}\n"
"bind Listbox <Left> {\n"
"%W xview scroll -1 units\n"
"}\n"
"bind Listbox <Control-Left> {\n"
"%W xview scroll -1 pages\n"
"}\n"
"bind Listbox <Right> {\n"
"%W xview scroll 1 units\n"
"}\n"
"bind Listbox <Control-Right> {\n"
"%W xview scroll 1 pages\n"
"}\n"
"bind Listbox <Prior> {\n"
"%W yview scroll -1 pages\n"
"%W activate @0,0\n"
"}\n"
"bind Listbox <Next> {\n"
"%W yview scroll 1 pages\n"
"%W activate @0,0\n"
"}\n"
"bind Listbox <Control-Prior> {\n"
"%W xview scroll -1 pages\n"
"}\n"
"bind Listbox <Control-Next> {\n"
"%W xview scroll 1 pages\n"
"}\n"
"bind Listbox <Home> {\n"
"%W xview moveto 0\n"
"}\n"
"bind Listbox <End> {\n"
"%W xview moveto 1\n"
"}\n"
"bind Listbox <Control-Home> {\n"
"%W activate 0\n"
"%W see 0\n"
"%W selection clear 0 end\n"
"%W selection set 0\n"
"}\n"
"bind Listbox <Shift-Control-Home> {\n"
"tkListboxDataExtend %W 0\n"
"}\n"
"bind Listbox <Control-End> {\n"
"%W activate end\n"
"%W see end\n"
"%W selection clear 0 end\n"
"%W selection set end\n"
"}\n"
"bind Listbox <Shift-Control-End> {\n"
"tkListboxDataExtend %W end\n"
"}\n"
"bind Listbox <F16> {\n"
"if {[selection own -displayof %W] == \"%W\"} {\n"
"clipboard clear -displayof %W\n"
"clipboard append -displayof %W [selection get -displayof %W]\n"
"}\n"
"}\n"
"bind Listbox <space> {\n"
"tkListboxBeginSelect %W [%W index active]\n"
"}\n"
"bind Listbox <Select> {\n"
"tkListboxBeginSelect %W [%W index active]\n"
"}\n"
"bind Listbox <Control-Shift-space> {\n"
"tkListboxBeginExtend %W [%W index active]\n"
"}\n"
"bind Listbox <Shift-Select> {\n"
"tkListboxBeginExtend %W [%W index active]\n"
"}\n"
"bind Listbox <Escape> {\n"
"tkListboxCancel %W\n"
"}\n"
"bind Listbox <Control-slash> {\n"
"tkListboxSelectAll %W\n"
"}\n"
"bind Listbox <Control-backslash> {\n"
"if {[%W cget -selectmode] != \"browse\"} {\n"
"%W selection clear 0 end\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"bind Listbox <2> {\n"
"%W scan mark %x %y\n"
"}\n"
"bind Listbox <B2-Motion> {\n"
"%W scan dragto %x %y\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxBeginSelect {w el} {\n"
"global tkPriv\n"
"if {[$w cget -selectmode]  == \"multiple\"} {\n"
"if [$w selection includes $el] {\n"
"$w selection clear $el\n"
"} else {\n"
"$w selection set $el\n"
"}\n"
"} else {\n"
"$w selection clear 0 end\n"
"$w selection set $el\n"
"$w selection anchor $el\n"
"set tkPriv(listboxSelection) {}\n"
"set tkPriv(listboxPrev) $el\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxMotion {w el} {\n"
"global tkPriv\n"
"if {$el == $tkPriv(listboxPrev)} {\n"
"return\n"
"}\n"
"set anchor [$w index anchor]\n"
"switch [$w cget -selectmode] {\n"
"browse {\n"
"$w selection clear 0 end\n"
"$w selection set $el\n"
"set tkPriv(listboxPrev) $el\n"
"}\n"
"extended {\n"
"set i $tkPriv(listboxPrev)\n"
"if [$w selection includes anchor] {\n"
"$w selection clear $i $el\n"
"$w selection set anchor $el\n"
"} else {\n"
"$w selection clear $i $el\n"
"$w selection clear anchor $el\n"
"}\n"
"while {($i < $el) && ($i < $anchor)} {\n"
"if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {\n"
"$w selection set $i\n"
"}\n"
"incr i\n"
"}\n"
"while {($i > $el) && ($i > $anchor)} {\n"
"if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {\n"
"$w selection set $i\n"
"}\n"
"incr i -1\n"
"}\n"
"set tkPriv(listboxPrev) $el\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxBeginExtend {w el} {\n"
"if {([$w cget -selectmode] == \"extended\")\n"
"&& [$w selection includes anchor]} {\n"
"tkListboxMotion $w $el\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxBeginToggle {w el} {\n"
"global tkPriv\n"
"if {[$w cget -selectmode] == \"extended\"} {\n"
"set tkPriv(listboxSelection) [$w curselection]\n"
"set tkPriv(listboxPrev) $el\n"
"$w selection anchor $el\n"
"if [$w selection includes $el] {\n"
"$w selection clear $el\n"
"} else {\n"
"$w selection set $el\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxAutoScan {w} {\n"
"global tkPriv\n"
"if {![winfo exists $w]} return\n"
"set x $tkPriv(x)\n"
"set y $tkPriv(y)\n"
"if {$y >= [winfo height $w]} {\n"
"$w yview scroll 1 units\n"
"} elseif {$y < 0} {\n"
"$w yview scroll -1 units\n"
"} elseif {$x >= [winfo width $w]} {\n"
"$w xview scroll 2 units\n"
"} elseif {$x < 0} {\n"
"$w xview scroll -2 units\n"
"} else {\n"
"return\n"
"}\n"
"tkListboxMotion $w [$w index @$x,$y]\n"
"set tkPriv(afterId) [after 50 tkListboxAutoScan $w]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxUpDown {w amount} {\n"
"global tkPriv\n"
"$w activate [expr [$w index active] + $amount]\n"
"$w see active\n"
"switch [$w cget -selectmode] {\n"
"browse {\n"
"$w selection clear 0 end\n"
"$w selection set active\n"
"}\n"
"extended {\n"
"$w selection clear 0 end\n"
"$w selection set active\n"
"$w selection anchor active\n"
"set tkPriv(listboxPrev) [$w index active]\n"
"set tkPriv(listboxSelection) {}\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxExtendUpDown {w amount} {\n"
"if {[$w cget -selectmode] != \"extended\"} {\n"
"return\n"
"}\n"
"$w activate [expr [$w index active] + $amount]\n"
"$w see active\n"
"tkListboxMotion $w [$w index active]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxDataExtend {w el} {\n"
"set mode [$w cget -selectmode]\n"
"if {$mode == \"extended\"} {\n"
"$w activate $el\n"
"$w see $el\n"
"if [$w selection includes anchor] {\n"
"tkListboxMotion $w $el\n"
"}\n"
"} elseif {$mode == \"multiple\"} {\n"
"$w activate $el\n"
"$w see $el\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxCancel w {\n"
"global tkPriv\n"
"if {[$w cget -selectmode] != \"extended\"} {\n"
"return\n"
"}\n"
"set first [$w index anchor]\n"
"set last $tkPriv(listboxPrev)\n"
"if {$first > $last} {\n"
"set tmp $first\n"
"set first $last\n"
"set last $tmp\n"
"}\n"
"$w selection clear $first $last\n"
"while {$first <= $last} {\n"
"if {[lsearch $tkPriv(listboxSelection) $first] >= 0} {\n"
"$w selection set $first\n"
"}\n"
"incr first\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkListboxSelectAll w {\n"
"set mode [$w cget -selectmode]\n"
"if {($mode == \"single\") || ($mode == \"browse\")} {\n"
"$w selection clear 0 end\n"
"$w selection set active\n"
"} else {\n"
"$w selection set 0 end\n"
"}\n"
"}\n"
"";
#line 641 "et41.c"
Et_EvalInclude("listbox.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Menubutton <FocusIn> {}\n"
"bind Menubutton <Enter> {\n"
"tkMbEnter %W\n"
"}\n"
"bind Menubutton <Leave> {\n"
"tkMbLeave %W\n"
"}\n"
"bind Menubutton <1> {\n"
"if {$tkPriv(inMenubutton) != \"\"} {\n"
"tkMbPost $tkPriv(inMenubutton) %X %Y\n"
"}\n"
"}\n"
"bind Menubutton <Motion> {\n"
"tkMbMotion %W up %X %Y\n"
"}\n"
"bind Menubutton <B1-Motion> {\n"
"tkMbMotion %W down %X %Y\n"
"}\n"
"bind Menubutton <ButtonRelease-1> {\n"
"tkMbButtonUp %W\n"
"}\n"
"bind Menubutton <space> {\n"
"tkMbPost %W\n"
"tkMenuFirstEntry [%W cget -menu]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Menu <FocusIn> {}\n"
"bind Menu <Enter> {\n"
"set tkPriv(window) %W\n"
"if {\"%m\" != \"NotifyUngrab\"} {\n"
"focus %W\n"
"}\n"
"}\n"
"bind Menu <Leave> {\n"
"tkMenuLeave %W %X %Y %s\n"
"}\n"
"bind Menu <Motion> {\n"
"tkMenuMotion %W %y %s\n"
"}\n"
"bind Menu <ButtonPress> {\n"
"tkMenuButtonDown %W\n"
"}\n"
"bind Menu <ButtonRelease> {\n"
"tkMenuInvoke %W 1\n"
"}\n"
"bind Menu <space> {\n"
"tkMenuInvoke %W 0\n"
"}\n"
"bind Menu <Return> {\n"
"tkMenuInvoke %W 0\n"
"}\n"
"bind Menu <Escape> {\n"
"tkMenuEscape %W\n"
"}\n"
"bind Menu <Left> {\n"
"tkMenuLeftRight %W left\n"
"}\n"
"bind Menu <Right> {\n"
"tkMenuLeftRight %W right\n"
"}\n"
"bind Menu <Up> {\n"
"tkMenuNextEntry %W -1\n"
"}\n"
"bind Menu <Down> {\n"
"tkMenuNextEntry %W +1\n"
"}\n"
"bind Menu <KeyPress> {\n"
"tkTraverseWithinMenu %W %A\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"bind all <Alt-KeyPress> {\n"
"tkTraverseToMenu %W %A\n"
"}\n"
"bind all <F10> {\n"
"tkFirstMenu %W\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMbEnter w {\n"
"global tkPriv\n"
"\n"
"if {$tkPriv(inMenubutton) != \"\"} {\n"
"tkMbLeave $tkPriv(inMenubutton)\n"
"}\n"
"set tkPriv(inMenubutton) $w\n"
"if {[$w cget -state] != \"disabled\"} {\n"
"$w configure -state active\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMbLeave w {\n"
"global tkPriv\n"
"\n"
"set tkPriv(inMenubutton) {}\n"
"if ![winfo exists $w] {\n"
"return\n"
"}\n"
"if {[$w cget -state] == \"active\"} {\n"
"$w configure -state normal\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMbPost {w {x {}} {y {}}} {\n"
"global tkPriv\n"
"if {([$w cget -state] == \"disabled\") || ($w == $tkPriv(postedMb))} {\n"
"return\n"
"}\n"
"set menu [$w cget -menu]\n"
"if {$menu == \"\"} {\n"
"return\n"
"}\n"
"if ![string match $w.* $menu] {\n"
"error \"can't post $menu:  it isn't a descendant of $w (this is a new requirement in Tk versions 3.0 and later)\"\n"
"}\n"
"set cur $tkPriv(postedMb)\n"
"if {$cur != \"\"} {\n"
"tkMenuUnpost {}\n"
"}\n"
"set tkPriv(cursor) [$w cget -cursor]\n"
"set tkPriv(relief) [$w cget -relief]\n"
"$w configure -cursor arrow\n"
"$w configure -relief raised\n"
"set tkPriv(postedMb) $w\n"
"set tkPriv(focus) [focus]\n"
"$menu activate none\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if [$w cget -indicatoron] {\n"
"if {$y == \"\"} {\n"
"set x [expr [winfo rootx $w] + [winfo width $w]/2]\n"
"set y [expr [winfo rooty $w] + [winfo height $w]/2]\n"
"}\n"
"tkPostOverPoint $menu $x $y [tkMenuFindName $menu [$w cget -text]]\n"
"} else {\n"
"$menu post [winfo rootx $w] [expr [winfo rooty $w]+[winfo height $w]]\n"
"}\n"
"focus $menu\n"
"tkSaveGrabInfo $w\n"
"grab -global $w\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuUnpost menu {\n"
"global tkPriv\n"
"set mb $tkPriv(postedMb)\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"catch {focus $tkPriv(focus)}\n"
"set tkPriv(focus) \"\"\n"
"\n"
"\n"
"\n"
"\n"
"catch {\n"
"if {$mb != \"\"} {\n"
"set menu [$mb cget -menu]\n"
"$menu unpost\n"
"set tkPriv(postedMb) {}\n"
"$mb configure -cursor $tkPriv(cursor)\n"
"$mb configure -relief $tkPriv(relief)\n"
"} elseif {$tkPriv(popup) != \"\"} {\n"
"$tkPriv(popup) unpost\n"
"set tkPriv(popup) {}\n"
"} elseif {[wm overrideredirect $menu]} {\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"while 1 {\n"
"set parent [winfo parent $menu]\n"
"if {([winfo class $parent] != \"Menu\")\n"
"|| ![winfo ismapped $parent]} {\n"
"break\n"
"}\n"
"$parent activate none\n"
"$parent postcascade none\n"
"if {![wm overrideredirect $parent]} {\n"
"break\n"
"}\n"
"set menu $parent\n"
"}\n"
"$menu unpost\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"if {$menu != \"\"} {\n"
"set grab [grab current $menu]\n"
"if {$grab != \"\"} {\n"
"grab release $grab\n"
"}\n"
"}\n"
"if {$tkPriv(oldGrab) != \"\"} {\n"
"\n"
"\n"
"\n"
"\n"
"catch {\n"
"if {$tkPriv(grabStatus) == \"global\"} {\n"
"grab set -global $tkPriv(oldGrab)\n"
"} else {\n"
"grab set $tkPriv(oldGrab)\n"
"}\n"
"}\n"
"set tkPriv(oldGrab) \"\"\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMbMotion {w upDown rootx rooty} {\n"
"global tkPriv\n"
"\n"
"if {$tkPriv(inMenubutton) == $w} {\n"
"return\n"
"}\n"
"set new [winfo containing $rootx $rooty]\n"
"if {($new != $tkPriv(inMenubutton)) && (($new == \"\")\n"
"|| ([winfo toplevel $new] == [winfo toplevel $w]))} {\n"
"if {$tkPriv(inMenubutton) != \"\"} {\n"
"tkMbLeave $tkPriv(inMenubutton)\n"
"}\n"
"if {($new != \"\") && ([winfo class $new] == \"Menubutton\")\n"
"&& ([$new cget -indicatoron] == 0)\n"
"&& ([$w cget -indicatoron] == 0)} {\n"
"if {$upDown == \"down\"} {\n"
"tkMbPost $new $rootx $rooty\n"
"} else {\n"
"tkMbEnter $new\n"
"}\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMbButtonUp w {\n"
"global tkPriv\n"
"\n"
"if  {($tkPriv(postedMb) == $w) && ($tkPriv(inMenubutton) == $w)} {\n"
"tkMenuFirstEntry [$tkPriv(postedMb) cget -menu]\n"
"} else {\n"
"tkMenuUnpost {}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuMotion {menu y state} {\n"
"global tkPriv\n"
"if {$menu == $tkPriv(window)} {\n"
"$menu activate @$y\n"
"}\n"
"if {($state & 0x1f00) != 0} {\n"
"$menu postcascade active\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuButtonDown menu {\n"
"global tkPriv\n"
"$menu postcascade active\n"
"if {$tkPriv(postedMb) != \"\"} {\n"
"grab -global $tkPriv(postedMb)\n"
"} else {\n"
"while {[wm overrideredirect $menu]\n"
"&& ([winfo class [winfo parent $menu]] == \"Menu\")\n"
"&& [winfo ismapped [winfo parent $menu]]} {\n"
"set menu [winfo parent $menu]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if {$menu != [grab current $menu]} {\n"
"tkSaveGrabInfo $menu\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"grab -global $menu\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuLeave {menu rootx rooty state} {\n"
"global tkPriv\n"
"set tkPriv(window) {}\n"
"if {[$menu index active] == \"none\"} {\n"
"return\n"
"}\n"
"if {([$menu type active] == \"cascade\")\n"
"&& ([winfo containing $rootx $rooty]\n"
"== [$menu entrycget active -menu])} {\n"
"return\n"
"}\n"
"$menu activate none\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuInvoke {w buttonRelease} {\n"
"global tkPriv\n"
"\n"
"if {$buttonRelease && ($tkPriv(window) == \"\")} {\n"
"\n"
"\n"
"\n"
"\n"
"$w postcascade none\n"
"$w activate none\n"
"tkMenuUnpost $w\n"
"return\n"
"}\n"
"if {[$w type active] == \"cascade\"} {\n"
"$w postcascade active\n"
"set menu [$w entrycget active -menu]\n"
"tkMenuFirstEntry $menu\n"
"} elseif {[$w type active] == \"tearoff\"} {\n"
"tkMenuUnpost $w\n"
"tkTearOffMenu $w\n"
"} else {\n"
"tkMenuUnpost $w\n"
"uplevel #0 [list $w invoke active]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuEscape menu {\n"
"if {[winfo class [winfo parent $menu]] != \"Menu\"} {\n"
"tkMenuUnpost $menu\n"
"} else {\n"
"tkMenuLeftRight $menu -1\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuLeftRight {menu direction} {\n"
"global tkPriv\n"
"\n"
"\n"
"\n"
"if {$direction == \"right\"} {\n"
"set count 1\n"
"if {[$menu type active] == \"cascade\"} {\n"
"$menu postcascade active\n"
"set m2 [$menu entrycget active -menu]\n"
"if {$m2 != \"\"} {\n"
"tkMenuFirstEntry $m2\n"
"}\n"
"return\n"
"}\n"
"} else {\n"
"set count -1\n"
"set m2 [winfo parent $menu]\n"
"if {[winfo class $m2] == \"Menu\"} {\n"
"$menu activate none\n"
"focus $m2\n"
"\n"
"\n"
"\n"
"set tmp [$m2 index active]\n"
"$m2 activate none\n"
"$m2 activate $tmp\n"
"return\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"set w $tkPriv(postedMb)\n"
"if {$w == \"\"} {\n"
"return\n"
"}\n"
"set buttons [winfo children [winfo parent $w]]\n"
"set length [llength $buttons]\n"
"set i [expr [lsearch -exact $buttons $w] + $count]\n"
"while 1 {\n"
"while {$i < 0} {\n"
"incr i $length\n"
"}\n"
"while {$i >= $length} {\n"
"incr i -$length\n"
"}\n"
"set mb [lindex $buttons $i]\n"
"if {([winfo class $mb] == \"Menubutton\")\n"
"&& ([$mb cget -state] != \"disabled\")\n"
"&& ([$mb cget -menu] != \"\")\n"
"&& ([[$mb cget -menu] index last] != \"none\")} {\n"
"break\n"
"}\n"
"if {$mb == $w} {\n"
"return\n"
"}\n"
"incr i $count\n"
"}\n"
"tkMbPost $mb\n"
"tkMenuFirstEntry [$mb cget -menu]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuNextEntry {menu count} {\n"
"global tkPriv\n"
"if {[$menu index last] == \"none\"} {\n"
"return\n"
"}\n"
"set length [expr [$menu index last]+1]\n"
"set quitAfter $length\n"
"set active [$menu index active]\n"
"if {$active == \"none\"} {\n"
"set i 0\n"
"} else {\n"
"set i [expr $active + $count]\n"
"}\n"
"while 1 {\n"
"if {$quitAfter <= 0} {\n"
"\n"
"\n"
"\n"
"return\n"
"}\n"
"while {$i < 0} {\n"
"incr i $length\n"
"}\n"
"while {$i >= $length} {\n"
"incr i -$length\n"
"}\n"
"if {[catch {$menu entrycget $i -state} state] == 0} {\n"
"if {$state != \"disabled\"} {\n"
"break\n"
"}\n"
"}\n"
"if {$i == $active} {\n"
"return\n"
"}\n"
"incr i $count\n"
"incr quitAfter -1\n"
"}\n"
"$menu activate $i\n"
"$menu postcascade $i\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuFind {w char} {\n"
"global tkPriv\n"
"set char [string tolower $char]\n"
"\n"
"foreach child [winfo child $w] {\n"
"switch [winfo class $child] {\n"
"Menubutton {\n"
"set char2 [string index [$child cget -text] \\\n"
"[$child cget -underline]]\n"
"if {([string compare $char [string tolower $char2]] == 0)\n"
"|| ($char == \"\")} {\n"
"if {[$child cget -state] != \"disabled\"} {\n"
"return $child\n"
"}\n"
"}\n"
"}\n"
"Frame {\n"
"set match [tkMenuFind $child $char]\n"
"if {$match != \"\"} {\n"
"return $match\n"
"}\n"
"}\n"
"}\n"
"}\n"
"return {}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTraverseToMenu {w char} {\n"
"global tkPriv\n"
"if {$char == \"\"} {\n"
"return\n"
"}\n"
"while {[winfo class $w] == \"Menu\"} {\n"
"if {$tkPriv(postedMb) == \"\"} {\n"
"return\n"
"}\n"
"set w [winfo parent $w]\n"
"}\n"
"set w [tkMenuFind [winfo toplevel $w] $char]\n"
"if {$w != \"\"} {\n"
"tkMbPost $w\n"
"tkMenuFirstEntry [$w cget -menu]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkFirstMenu w {\n"
"set w [tkMenuFind [winfo toplevel $w] \"\"]\n"
"if {$w != \"\"} {\n"
"tkMbPost $w\n"
"tkMenuFirstEntry [$w cget -menu]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTraverseWithinMenu {w char} {\n"
"if {$char == \"\"} {\n"
"return\n"
"}\n"
"set char [string tolower $char]\n"
"set last [$w index last]\n"
"if {$last == \"none\"} {\n"
"return\n"
"}\n"
"for {set i 0} {$i <= $last} {incr i} {\n"
"if [catch {set char2 [string index \\\n"
"[$w entrycget $i -label] \\\n"
"[$w entrycget $i -underline]]}] {\n"
"continue\n"
"}\n"
"if {[string compare $char [string tolower $char2]] == 0} {\n"
"if {[$w type $i] == \"cascade\"} {\n"
"$w postcascade $i\n"
"$w activate $i\n"
"set m2 [$w entrycget $i -menu]\n"
"if {$m2 != \"\"} {\n"
"tkMenuFirstEntry $m2\n"
"}\n"
"} else {\n"
"tkMenuUnpost $w\n"
"uplevel #0 [list $w invoke $i]\n"
"}\n"
"return\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuFirstEntry menu {\n"
"if {$menu == \"\"} {\n"
"return\n"
"}\n"
"focus $menu\n"
"if {[$menu index active] != \"none\"} {\n"
"return\n"
"}\n"
"set last [$menu index last]\n"
"if {$last == \"none\"} {\n"
"return\n"
"}\n"
"for {set i 0} {$i <= $last} {incr i} {\n"
"if {([catch {set state [$menu entrycget $i -state]}] == 0)\n"
"&& ($state != \"disabled\") && ([$menu type $i] != \"tearoff\")} {\n"
"$menu activate $i\n"
"return\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuFindName {menu s} {\n"
"set i \"\"\n"
"if {![regexp {^active$|^last$|^none$|^[0-9]|^@} $s]} {\n"
"catch {set i [$menu index $s]}\n"
"return $i\n"
"}\n"
"set last [$menu index last]\n"
"if {$last == \"none\"} {\n"
"return\n"
"}\n"
"for {set i 0} {$i <= $last} {incr i} {\n"
"if ![catch {$menu entrycget $i -label} label] {\n"
"if {$label == $s} {\n"
"return $i\n"
"}\n"
"}\n"
"}\n"
"return \"\"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkPostOverPoint {menu x y {entry {}}}  {\n"
"if {$entry != {}} {\n"
"if {$entry == [$menu index last]} {\n"
"incr y [expr -([$menu yposition $entry] \\\n"
"+ [winfo reqheight $menu])/2]\n"
"} else {\n"
"incr y [expr -([$menu yposition $entry] \\\n"
"+ [$menu yposition [expr $entry+1]])/2]\n"
"}\n"
"incr x [expr -[winfo reqwidth $menu]/2]\n"
"}\n"
"$menu post $x $y\n"
"if {($entry != {}) && ([$menu entrycget $entry -state] != \"disabled\")} {\n"
"$menu activate $entry\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkSaveGrabInfo w {\n"
"global tkPriv\n"
"set tkPriv(oldGrab) [grab current $w]\n"
"if {$tkPriv(oldGrab) != \"\"} {\n"
"set tkPriv(grabStatus) [grab status $tkPriv(oldGrab)]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_popup {menu x y {entry {}}} {\n"
"global tkPriv\n"
"if {($tkPriv(popup) != \"\") || ($tkPriv(postedMb) != \"\")} {\n"
"tkMenuUnpost {}\n"
"}\n"
"tkPostOverPoint $menu $x $y $entry\n"
"tkSaveGrabInfo $menu\n"
"grab -global $menu\n"
"set tkPriv(popup) $menu\n"
"set tkPriv(focus) [focus]\n"
"focus $menu\n"
"}\n"
"";
#line 642 "et41.c"
Et_EvalInclude("menu.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_menuBar args {}\n"
"proc tk_bindForTraversal args {}\n"
"";
#line 643 "et41.c"
Et_EvalInclude("obsolete.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_optionMenu {w varName firstValue args} {\n"
"upvar #0 $varName var\n"
"\n"
"if ![info exists var] {\n"
"set var $firstValue\n"
"}\n"
"menubutton $w -textvariable $varName -indicatoron 1 -menu $w.menu \\\n"
"-relief raised -bd 2 -highlightthickness 2 -anchor c\n"
"menu $w.menu -tearoff 0\n"
"$w.menu add command -label $firstValue \\\n"
"-command [list set $varName $firstValue]\n"
"foreach i $args {\n"
"$w.menu add command -label $i -command [list set $varName $i]\n"
"}\n"
"return $w.menu\n"
"}\n"
"";
#line 644 "et41.c"
Et_EvalInclude("optMenu.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_setPalette args {\n"
"global tkPalette\n"
"\n"
"\n"
"\n"
"\n"
"if {[llength $args] == 1} {\n"
"set new(background) [lindex $args 0]\n"
"} else {\n"
"array set new $args\n"
"}\n"
"if ![info exists new(background)] {\n"
"error \"must specify a background color\"\n"
"}\n"
"if ![info exists new(foreground)] {\n"
"set new(foreground) black\n"
"}\n"
"set bg [winfo rgb . $new(background)]\n"
"set fg [winfo rgb . $new(foreground)]\n"
"set darkerBg [format #%02x%02x%02x [expr (9*[lindex $bg 0])/2560] \\\n"
"[expr (9*[lindex $bg 1])/2560] [expr (9*[lindex $bg 2])/2560]]\n"
"foreach i {activeForeground insertBackground selectForeground \\\n"
"highlightColor} {\n"
"if ![info exists new($i)] {\n"
"set new($i) $new(foreground)\n"
"}\n"
"}\n"
"if ![info exists new(disabledForeground)] {\n"
"set new(disabledForeground) [format #%02x%02x%02x \\\n"
"[expr (3*[lindex $bg 0] + [lindex $fg 0])/1024] \\\n"
"[expr (3*[lindex $bg 1] + [lindex $fg 1])/1024] \\\n"
"[expr (3*[lindex $bg 2] + [lindex $fg 2])/1024]]\n"
"}\n"
"if ![info exists new(highlightBackground)] {\n"
"set new(highlightBackground) $new(background)\n"
"}\n"
"if ![info exists new(activeBackground)] {\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"foreach i {0 1 2} {\n"
"set light($i) [expr [lindex $bg $i]/256]\n"
"set inc1 [expr ($light($i)*15)/100]\n"
"set inc2 [expr (255-$light($i))/3]\n"
"if {$inc1 > $inc2} {\n"
"incr light($i) $inc1\n"
"} else {\n"
"incr light($i) $inc2\n"
"}\n"
"if {$light($i) > 255} {\n"
"set light($i) 255\n"
"}\n"
"}\n"
"set new(activeBackground) [format #%02x%02x%02x $light(0) \\\n"
"$light(1) $light(2)]\n"
"}\n"
"if ![info exists new(selectBackground)] {\n"
"set new(selectBackground) $darkerBg\n"
"}\n"
"if ![info exists new(troughColor)] {\n"
"set new(troughColor) $darkerBg\n"
"}\n"
"if ![info exists new(selectColor)] {\n"
"set new(selectColor) #b03060\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if ![info exists tkPalette] {\n"
"checkbutton .c14732\n"
"entry .e14732\n"
"scrollbar .s14732\n"
"set tkPalette(activeBackground) \\\n"
"[lindex [.c14732 configure -activebackground] 3]\n"
"set tkPalette(activeForeground) \\\n"
"[lindex [.c14732 configure -activeforeground] 3]\n"
"set tkPalette(background) \\\n"
"[lindex [.c14732 configure -background] 3]\n"
"set tkPalette(disabledForeground) \\\n"
"[lindex [.c14732 configure -disabledforeground] 3]\n"
"set tkPalette(foreground) \\\n"
"[lindex [.c14732 configure -foreground] 3]\n"
"set tkPalette(highlightBackground) \\\n"
"[lindex [.c14732 configure -highlightbackground] 3]\n"
"set tkPalette(highlightColor) \\\n"
"[lindex [.c14732 configure -highlightcolor] 3]\n"
"set tkPalette(insertBackground) \\\n"
"[lindex [.e14732 configure -insertbackground] 3]\n"
"set tkPalette(selectColor) \\\n"
"[lindex [.c14732 configure -selectcolor] 3]\n"
"set tkPalette(selectBackground) \\\n"
"[lindex [.e14732 configure -selectbackground] 3]\n"
"set tkPalette(selectForeground) \\\n"
"[lindex [.e14732 configure -selectforeground] 3]\n"
"set tkPalette(troughColor) \\\n"
"[lindex [.s14732 configure -troughcolor] 3]\n"
"destroy .c14732 .e14732 .s14732\n"
"}\n"
"tkRecolorTree . new\n"
"\n"
"\n"
"\n"
"\n"
"foreach option [array names new] {\n"
"option add *$option $new($option) widgetDefault\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"array set tkPalette [array get new]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkRecolorTree {w colors} {\n"
"global tkPalette\n"
"upvar $colors c\n"
"foreach dbOption [array names c] {\n"
"set option -[string tolower $dbOption]\n"
"if ![catch {$w cget $option} value] {\n"
"if {$value == $tkPalette($dbOption)} {\n"
"$w configure $option $c($dbOption)\n"
"}\n"
"}\n"
"}\n"
"foreach child [winfo children $w] {\n"
"tkRecolorTree $child c\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkDarken {color percent} {\n"
"set l [winfo rgb . $color]\n"
"set red [expr [lindex $l 0]/256]\n"
"set green [expr [lindex $l 1]/256]\n"
"set blue [expr [lindex $l 2]/256]\n"
"set red [expr ($red*$percent)/100]\n"
"if {$red > 255} {\n"
"set red 255\n"
"}\n"
"set green [expr ($green*$percent)/100]\n"
"if {$green > 255} {\n"
"set green 255\n"
"}\n"
"set blue [expr ($blue*$percent)/100]\n"
"if {$blue > 255} {\n"
"set blue 255\n"
"}\n"
"format #%02x%02x%02x $red $green $blue\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_bisque {} {\n"
"tk_setPalette activeBackground #e6ceb1 activeForeground black \\\n"
"background #ffe4c4 disabledForeground #b0b0b0 foreground black \\\n"
"highlightBackground #ffe4c4 highlightColor black \\\n"
"insertBackground black selectColor #b03060 \\\n"
"selectBackground #e6ceb1 selectForeground black \\\n"
"troughColor #cdb79e\n"
"}\n"
"";
#line 645 "et41.c"
Et_EvalInclude("palette.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc parray {a {pattern *}} {\n"
"upvar 1 $a array\n"
"if ![array exists array] {\n"
"error \"\\\"$a\\\" isn't an array\"\n"
"}\n"
"set maxl 0\n"
"foreach name [lsort [array names array $pattern]] {\n"
"if {[string length $name] > $maxl} {\n"
"set maxl [string length $name]\n"
"}\n"
"}\n"
"set maxl [expr {$maxl + [string length $a] + 2}]\n"
"foreach name [lsort [array names array $pattern]] {\n"
"set nameString [format %s(%s) $a $name]\n"
"puts stdout [format \"%-*s = %s\" $maxl $nameString $array($name)]\n"
"}\n"
"}\n"
"";
#line 646 "et41.c"
Et_EvalInclude("parray.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextClipboardKeysyms {copy cut paste} {\n"
"bind Text <$copy> {tk_textCopy %W}\n"
"bind Text <$cut> {tk_textCut %W}\n"
"bind Text <$paste> {tk_textPaste %W}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Text <1> {\n"
"tkTextButton1 %W %x %y\n"
"%W tag remove sel 0.0 end\n"
"}\n"
"bind Text <B1-Motion> {\n"
"set tkPriv(x) %x\n"
"set tkPriv(y) %y\n"
"tkTextSelectTo %W %x %y\n"
"}\n"
"bind Text <Double-1> {\n"
"set tkPriv(selectMode) word\n"
"tkTextSelectTo %W %x %y\n"
"catch {%W mark set insert sel.first}\n"
"}\n"
"bind Text <Triple-1> {\n"
"set tkPriv(selectMode) line\n"
"tkTextSelectTo %W %x %y\n"
"catch {%W mark set insert sel.first}\n"
"}\n"
"bind Text <Shift-1> {\n"
"tkTextResetAnchor %W @%x,%y\n"
"set tkPriv(selectMode) char\n"
"tkTextSelectTo %W %x %y\n"
"}\n"
"bind Text <Double-Shift-1> {\n"
"set tkPriv(selectMode) word\n"
"tkTextSelectTo %W %x %y\n"
"}\n"
"bind Text <Triple-Shift-1> {\n"
"set tkPriv(selectMode) line\n"
"tkTextSelectTo %W %x %y\n"
"}\n"
"bind Text <B1-Leave> {\n"
"set tkPriv(x) %x\n"
"set tkPriv(y) %y\n"
"tkTextAutoScan %W\n"
"}\n"
"bind Text <B1-Enter> {\n"
"tkCancelRepeat\n"
"}\n"
"bind Text <ButtonRelease-1> {\n"
"tkCancelRepeat\n"
"}\n"
"bind Text <Control-1> {\n"
"%W mark set insert @%x,%y\n"
"}\n"
"bind Text <ButtonRelease-2> {\n"
"if {!$tkPriv(mouseMoved) || $tk_strictMotif} {\n"
"tkTextPaste %W %x %y\n"
"}\n"
"}\n"
"bind Text <Left> {\n"
"tkTextSetCursor %W insert-1c\n"
"}\n"
"bind Text <Right> {\n"
"tkTextSetCursor %W insert+1c\n"
"}\n"
"bind Text <Up> {\n"
"tkTextSetCursor %W [tkTextUpDownLine %W -1]\n"
"}\n"
"bind Text <Down> {\n"
"tkTextSetCursor %W [tkTextUpDownLine %W 1]\n"
"}\n"
"bind Text <Shift-Left> {\n"
"tkTextKeySelect %W [%W index {insert - 1c}]\n"
"}\n"
"bind Text <Shift-Right> {\n"
"tkTextKeySelect %W [%W index {insert + 1c}]\n"
"}\n"
"bind Text <Shift-Up> {\n"
"tkTextKeySelect %W [tkTextUpDownLine %W -1]\n"
"}\n"
"bind Text <Shift-Down> {\n"
"tkTextKeySelect %W [tkTextUpDownLine %W 1]\n"
"}\n"
"bind Text <Control-Left> {\n"
"tkTextSetCursor %W [%W index {insert - 1c wordstart}]\n"
"}\n"
"bind Text <Control-Right> {\n"
"tkTextSetCursor %W [%W index {insert wordend}]\n"
"}\n"
"bind Text <Control-Up> {\n"
"tkTextSetCursor %W [tkTextPrevPara %W insert]\n"
"}\n"
"bind Text <Control-Down> {\n"
"tkTextSetCursor %W [tkTextNextPara %W insert]\n"
"}\n"
"bind Text <Shift-Control-Left> {\n"
"tkTextKeySelect %W [%W index {insert - 1c wordstart}]\n"
"}\n"
"bind Text <Shift-Control-Right> {\n"
"tkTextKeySelect %W [%W index {insert wordend}]\n"
"}\n"
"bind Text <Shift-Control-Up> {\n"
"tkTextKeySelect %W [tkTextPrevPara %W insert]\n"
"}\n"
"bind Text <Shift-Control-Down> {\n"
"tkTextKeySelect %W [tkTextNextPara %W insert]\n"
"}\n"
"bind Text <Prior> {\n"
"tkTextSetCursor %W [tkTextScrollPages %W -1]\n"
"}\n"
"bind Text <Shift-Prior> {\n"
"tkTextKeySelect %W [tkTextScrollPages %W -1]\n"
"}\n"
"bind Text <Next> {\n"
"tkTextSetCursor %W [tkTextScrollPages %W 1]\n"
"}\n"
"bind Text <Shift-Next> {\n"
"tkTextKeySelect %W [tkTextScrollPages %W 1]\n"
"}\n"
"bind Text <Control-Prior> {\n"
"%W xview scroll -1 page\n"
"}\n"
"bind Text <Control-Next> {\n"
"%W xview scroll 1 page\n"
"}\n"
"\n"
"bind Text <Home> {\n"
"tkTextSetCursor %W {insert linestart}\n"
"}\n"
"bind Text <Shift-Home> {\n"
"tkTextKeySelect %W {insert linestart}\n"
"}\n"
"bind Text <End> {\n"
"tkTextSetCursor %W {insert lineend}\n"
"}\n"
"bind Text <Shift-End> {\n"
"tkTextKeySelect %W {insert lineend}\n"
"}\n"
"bind Text <Control-Home> {\n"
"tkTextSetCursor %W 1.0\n"
"}\n"
"bind Text <Control-Shift-Home> {\n"
"tkTextKeySelect %W 1.0\n"
"}\n"
"bind Text <Control-End> {\n"
"tkTextSetCursor %W {end - 1 char}\n"
"}\n"
"bind Text <Control-Shift-End> {\n"
"tkTextKeySelect %W {end - 1 char}\n"
"}\n"
"\n"
"bind Text <Tab> {\n"
"tkTextInsert %W \\t\n"
"focus %W\n"
"break\n"
"}\n"
"bind Text <Shift-Tab> {\n"
"\n"
"\n"
"}\n"
"bind Text <Control-Tab> {\n"
"focus [tk_focusNext %W]\n"
"}\n"
"bind Text <Control-Shift-Tab> {\n"
"focus [tk_focusPrev %W]\n"
"}\n"
"bind Text <Control-i> {\n"
"tkTextInsert %W \\t\n"
"}\n"
"bind Text <Return> {\n"
"tkTextInsert %W \\n\n"
"}\n"
"bind Text <Delete> {\n"
"if {[%W tag nextrange sel 1.0 end] != \"\"} {\n"
"%W delete sel.first sel.last\n"
"} else {\n"
"%W delete insert\n"
"%W see insert\n"
"}\n"
"}\n"
"bind Text <BackSpace> {\n"
"if {[%W tag nextrange sel 1.0 end] != \"\"} {\n"
"%W delete sel.first sel.last\n"
"} elseif [%W compare insert != 1.0] {\n"
"%W delete insert-1c\n"
"%W see insert\n"
"}\n"
"}\n"
"\n"
"bind Text <Control-space> {\n"
"%W mark set anchor insert\n"
"}\n"
"bind Text <Select> {\n"
"%W mark set anchor insert\n"
"}\n"
"bind Text <Control-Shift-space> {\n"
"set tkPriv(selectMode) char\n"
"tkTextKeyExtend %W insert\n"
"}\n"
"bind Text <Shift-Select> {\n"
"set tkPriv(selectMode) char\n"
"tkTextKeyExtend %W insert\n"
"}\n"
"bind Text <Control-slash> {\n"
"%W tag add sel 1.0 end\n"
"}\n"
"bind Text <Control-backslash> {\n"
"%W tag remove sel 1.0 end\n"
"}\n"
"tkTextClipboardKeysyms F16 F20 F18\n"
"bind Text <Insert> {\n"
"catch {tkTextInsert %W [selection get -displayof %W]}\n"
"}\n"
"bind Text <KeyPress> {\n"
"tkTextInsert %W %A\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Text <Alt-KeyPress> {# nothing }\n"
"bind Text <Meta-KeyPress> {# nothing}\n"
"bind Text <Control-KeyPress> {# nothing}\n"
"bind Text <Escape> {# nothing}\n"
"bind Text <KP_Enter> {# nothing}\n"
"\n"
"\n"
"\n"
"bind Text <Control-a> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W {insert linestart}\n"
"}\n"
"}\n"
"bind Text <Control-b> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W insert-1c\n"
"}\n"
"}\n"
"bind Text <Control-d> {\n"
"if !$tk_strictMotif {\n"
"%W delete insert\n"
"}\n"
"}\n"
"bind Text <Control-e> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W {insert lineend}\n"
"}\n"
"}\n"
"bind Text <Control-f> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W insert+1c\n"
"}\n"
"}\n"
"bind Text <Control-k> {\n"
"if !$tk_strictMotif {\n"
"if [%W compare insert == {insert lineend}] {\n"
"%W delete insert\n"
"} else {\n"
"%W delete insert {insert lineend}\n"
"}\n"
"}\n"
"}\n"
"bind Text <Control-n> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W [tkTextUpDownLine %W 1]\n"
"}\n"
"}\n"
"bind Text <Control-o> {\n"
"if !$tk_strictMotif {\n"
"%W insert insert \\n\n"
"%W mark set insert insert-1c\n"
"}\n"
"}\n"
"bind Text <Control-p> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W [tkTextUpDownLine %W -1]\n"
"}\n"
"}\n"
"bind Text <Control-t> {\n"
"if !$tk_strictMotif {\n"
"tkTextTranspose %W\n"
"}\n"
"}\n"
"bind Text <Control-v> {\n"
"if !$tk_strictMotif {\n"
"tkTextScrollPages %W 1\n"
"}\n"
"}\n"
"bind Text <Meta-b> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W {insert - 1c wordstart}\n"
"}\n"
"}\n"
"bind Text <Meta-d> {\n"
"if !$tk_strictMotif {\n"
"%W delete insert {insert wordend}\n"
"}\n"
"}\n"
"bind Text <Meta-f> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W {insert wordend}\n"
"}\n"
"}\n"
"bind Text <Meta-less> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W 1.0\n"
"}\n"
"}\n"
"bind Text <Meta-greater> {\n"
"if !$tk_strictMotif {\n"
"tkTextSetCursor %W end-1c\n"
"}\n"
"}\n"
"bind Text <Meta-BackSpace> {\n"
"if !$tk_strictMotif {\n"
"%W delete {insert -1c wordstart} insert\n"
"}\n"
"}\n"
"bind Text <Meta-Delete> {\n"
"if !$tk_strictMotif {\n"
"%W delete {insert -1c wordstart} insert\n"
"}\n"
"}\n"
"if !$tk_strictMotif {\n"
"tkTextClipboardKeysyms Meta-w Control-w Control-y\n"
"}\n"
"\n"
"\n"
"\n"
"bind Text <Control-h> {\n"
"if !$tk_strictMotif {\n"
"if [%W compare insert != 1.0] {\n"
"%W delete insert-1c\n"
"%W see insert\n"
"}\n"
"}\n"
"}\n"
"bind Text <2> {\n"
"if !$tk_strictMotif {\n"
"%W scan mark %x %y\n"
"set tkPriv(x) %x\n"
"set tkPriv(y) %y\n"
"set tkPriv(mouseMoved) 0\n"
"}\n"
"}\n"
"bind Text <B2-Motion> {\n"
"if !$tk_strictMotif {\n"
"if {(%x != $tkPriv(x)) || (%y != $tkPriv(y))} {\n"
"set tkPriv(mouseMoved) 1\n"
"}\n"
"if $tkPriv(mouseMoved) {\n"
"%W scan dragto %x %y\n"
"}\n"
"}\n"
"}\n"
"set tkPriv(prevPos) {}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextClosestGap {w x y} {\n"
"set pos [$w index @$x,$y]\n"
"set bbox [$w bbox $pos]\n"
"if ![string compare $bbox \"\"] {\n"
"return $pos\n"
"}\n"
"if {($x - [lindex $bbox 0]) < ([lindex $bbox 2]/2)} {\n"
"return $pos\n"
"}\n"
"$w index \"$pos + 1 char\"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextButton1 {w x y} {\n"
"global tkPriv\n"
"\n"
"set tkPriv(selectMode) char\n"
"set tkPriv(mouseMoved) 0\n"
"set tkPriv(pressX) $x\n"
"$w mark set insert [tkTextClosestGap $w $x $y]\n"
"$w mark set anchor insert\n"
"if {[$w cget -state] == \"normal\"} {focus $w}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextSelectTo {w x y} {\n"
"global tkPriv\n"
"\n"
"set cur [tkTextClosestGap $w $x $y]\n"
"if [catch {$w index anchor}] {\n"
"$w mark set anchor $cur\n"
"}\n"
"set anchor [$w index anchor]\n"
"if {[$w compare $cur != $anchor] || (abs($tkPriv(pressX) - $x) >= 3)} {\n"
"set tkPriv(mouseMoved) 1\n"
"}\n"
"switch $tkPriv(selectMode) {\n"
"char {\n"
"if [$w compare $cur < anchor] {\n"
"set first $cur\n"
"set last anchor\n"
"} else {\n"
"set first anchor\n"
"set last $cur\n"
"}\n"
"}\n"
"word {\n"
"if [$w compare $cur < anchor] {\n"
"set first [$w index \"$cur wordstart\"]\n"
"set last [$w index \"anchor - 1c wordend\"]\n"
"} else {\n"
"set first [$w index \"anchor wordstart\"]\n"
"set last [$w index \"$cur -1c wordend\"]\n"
"}\n"
"}\n"
"line {\n"
"if [$w compare $cur < anchor] {\n"
"set first [$w index \"$cur linestart\"]\n"
"set last [$w index \"anchor - 1c lineend + 1c\"]\n"
"} else {\n"
"set first [$w index \"anchor linestart\"]\n"
"set last [$w index \"$cur lineend + 1c\"]\n"
"}\n"
"}\n"
"}\n"
"if {$tkPriv(mouseMoved) || ($tkPriv(selectMode) != \"char\")} {\n"
"$w tag remove sel 0.0 $first\n"
"$w tag add sel $first $last\n"
"$w tag remove sel $last end\n"
"update idletasks\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextKeyExtend {w index} {\n"
"global tkPriv\n"
"\n"
"set cur [$w index $index]\n"
"if [catch {$w index anchor}] {\n"
"$w mark set anchor $cur\n"
"}\n"
"set anchor [$w index anchor]\n"
"if [$w compare $cur < anchor] {\n"
"set first $cur\n"
"set last anchor\n"
"} else {\n"
"set first anchor\n"
"set last $cur\n"
"}\n"
"$w tag remove sel 0.0 $first\n"
"$w tag add sel $first $last\n"
"$w tag remove sel $last end\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextPaste {w x y} {\n"
"$w mark set insert [tkTextClosestGap $w $x $y]\n"
"catch {$w insert insert [selection get -displayof $w]}\n"
"if {[$w cget -state] == \"normal\"} {focus $w}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextAutoScan {w} {\n"
"global tkPriv\n"
"if {![winfo exists $w]} return\n"
"if {$tkPriv(y) >= [winfo height $w]} {\n"
"$w yview scroll 2 units\n"
"} elseif {$tkPriv(y) < 0} {\n"
"$w yview scroll -2 units\n"
"} elseif {$tkPriv(x) >= [winfo width $w]} {\n"
"$w xview scroll 2 units\n"
"} elseif {$tkPriv(x) < 0} {\n"
"$w xview scroll -2 units\n"
"} else {\n"
"return\n"
"}\n"
"tkTextSelectTo $w $tkPriv(x) $tkPriv(y)\n"
"set tkPriv(afterId) [after 50 tkTextAutoScan $w]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextSetCursor {w pos} {\n"
"global tkPriv\n"
"\n"
"if [$w compare $pos == end] {\n"
"set pos {end - 1 chars}\n"
"}\n"
"$w mark set insert $pos\n"
"$w tag remove sel 1.0 end\n"
"$w see insert\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextKeySelect {w new} {\n"
"global tkPriv\n"
"\n"
"if {[$w tag nextrange sel 1.0 end] == \"\"} {\n"
"if [$w compare $new < insert] {\n"
"$w tag add sel $new insert\n"
"} else {\n"
"$w tag add sel insert $new\n"
"}\n"
"$w mark set anchor insert\n"
"} else {\n"
"if [$w compare $new < anchor] {\n"
"set first $new\n"
"set last anchor\n"
"} else {\n"
"set first anchor\n"
"set last $new\n"
"}\n"
"$w tag remove sel 1.0 $first\n"
"$w tag add sel $first $last\n"
"$w tag remove sel $last end\n"
"}\n"
"$w mark set insert $new\n"
"$w see insert\n"
"update idletasks\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextResetAnchor {w index} {\n"
"global tkPriv\n"
"\n"
"if {[$w tag ranges sel] == \"\"} {\n"
"$w mark set anchor $index\n"
"return\n"
"}\n"
"set a [$w index $index]\n"
"set b [$w index sel.first]\n"
"set c [$w index sel.last]\n"
"if [$w compare $a < $b] {\n"
"$w mark set anchor sel.last\n"
"return\n"
"}\n"
"if [$w compare $a > $c] {\n"
"$w mark set anchor sel.first\n"
"return\n"
"}\n"
"scan $a \"%d.%d\" lineA chA\n"
"scan $b \"%d.%d\" lineB chB\n"
"scan $c \"%d.%d\" lineC chC\n"
"if {$lineB < $lineC+2} {\n"
"set total [string length [$w get $b $c]]\n"
"if {$total <= 2} {\n"
"return\n"
"}\n"
"if {[string length [$w get $b $a]] < ($total/2)} {\n"
"$w mark set anchor sel.last\n"
"} else {\n"
"$w mark set anchor sel.first\n"
"}\n"
"return\n"
"}\n"
"if {($lineA-$lineB) < ($lineC-$lineA)} {\n"
"$w mark set anchor sel.last\n"
"} else {\n"
"$w mark set anchor sel.first\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextInsert {w s} {\n"
"if {($s == \"\") || ([$w cget -state] == \"disabled\")} {\n"
"return\n"
"}\n"
"catch {\n"
"if {[$w compare sel.first <= insert]\n"
"&& [$w compare sel.last >= insert]} {\n"
"$w delete sel.first sel.last\n"
"}\n"
"}\n"
"$w insert insert $s\n"
"$w see insert\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextUpDownLine {w n} {\n"
"global tkPriv\n"
"\n"
"set i [$w index insert]\n"
"scan $i \"%d.%d\" line char\n"
"if {[string compare $tkPriv(prevPos) $i] != 0} {\n"
"set tkPriv(char) $char\n"
"}\n"
"set new [$w index [expr $line + $n].$tkPriv(char)]\n"
"if {[$w compare $new == end] || [$w compare $new == \"insert linestart\"]} {\n"
"set new $i\n"
"}\n"
"set tkPriv(prevPos) $new\n"
"return $new\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextPrevPara {w pos} {\n"
"set pos [$w index \"$pos linestart\"]\n"
"while 1 {\n"
"if {(([$w get \"$pos - 1 line\"] == \"\\n\") && ([$w get $pos] != \"\\n\"))\n"
"|| ($pos == \"1.0\")} {\n"
"if [regexp -indices {^[  ]+(.)} [$w get $pos \"$pos lineend\"] \\\n"
"dummy index] {\n"
"set pos [$w index \"$pos + [lindex $index 0] chars\"]\n"
"}\n"
"if {[$w compare $pos != insert] || ($pos == \"1.0\")} {\n"
"return $pos\n"
"}\n"
"}\n"
"set pos [$w index \"$pos - 1 line\"]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextNextPara {w start} {\n"
"set pos [$w index \"$start linestart + 1 line\"]\n"
"while {[$w get $pos] != \"\\n\"} {\n"
"if [$w compare $pos == end] {\n"
"return [$w index \"end - 1c\"]\n"
"}\n"
"set pos [$w index \"$pos + 1 line\"]\n"
"}\n"
"while {[$w get $pos] == \"\\n\"} {\n"
"set pos [$w index \"$pos + 1 line\"]\n"
"if [$w compare $pos == end] {\n"
"return [$w index \"end - 1c\"]\n"
"}\n"
"}\n"
"if [regexp -indices {^[  ]+(.)} [$w get $pos \"$pos lineend\"] \\\n"
"dummy index] {\n"
"return [$w index \"$pos + [lindex $index 0] chars\"]\n"
"}\n"
"return $pos\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextScrollPages {w count} {\n"
"set bbox [$w bbox insert]\n"
"$w yview scroll $count pages\n"
"if {$bbox == \"\"} {\n"
"return [$w index @[expr [winfo height $w]/2],0]\n"
"}\n"
"return [$w index @[lindex $bbox 0],[lindex $bbox 1]]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTextTranspose w {\n"
"set pos insert\n"
"if [$w compare $pos != \"$pos lineend\"] {\n"
"set pos [$w index \"$pos + 1 char\"]\n"
"}\n"
"set new [$w get \"$pos - 1 char\"][$w get  \"$pos - 2 char\"]\n"
"if [$w compare \"$pos - 1 char\" == 1.0] {\n"
"return\n"
"}\n"
"$w delete \"$pos - 2 char\" $pos\n"
"$w insert insert $new\n"
"$w see insert\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_textCopy w {\n"
"if {[selection own -displayof $w] == \"$w\"} {\n"
"clipboard clear -displayof $w\n"
"catch {\n"
"clipboard append -displayof $w [selection get -displayof $w]\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_textCut w {\n"
"if {[selection own -displayof $w] == \"$w\"} {\n"
"clipboard clear -displayof $w\n"
"catch {\n"
"clipboard append -displayof $w [selection get -displayof $w]\n"
"$w delete sel.first sel.last\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tk_textPaste w {\n"
"catch {\n"
"$w insert insert [selection get -displayof $w \\\n"
"-selection CLIPBOARD]\n"
"}\n"
"}\n"
"";
#line 647 "et41.c"
Et_EvalInclude("text.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Scale <Enter> {\n"
"if $tk_strictMotif {\n"
"set tkPriv(activeBg) [%W cget -activebackground]\n"
"%W config -activebackground [%W cget -background]\n"
"}\n"
"tkScaleActivate %W %x %y\n"
"}\n"
"bind Scale <Motion> {\n"
"tkScaleActivate %W %x %y\n"
"}\n"
"bind Scale <Leave> {\n"
"if $tk_strictMotif {\n"
"%W config -activebackground $tkPriv(activeBg)\n"
"}\n"
"if {[%W cget -state] == \"active\"} {\n"
"%W configure -state normal\n"
"}\n"
"}\n"
"bind Scale <1> {\n"
"tkScaleButtonDown %W %x %y\n"
"}\n"
"bind Scale <B1-Motion> {\n"
"tkScaleDrag %W %x %y\n"
"}\n"
"bind Scale <B1-Leave> { }\n"
"bind Scale <B1-Enter> { }\n"
"bind Scale <ButtonRelease-1> {\n"
"tkCancelRepeat\n"
"tkScaleEndDrag %W\n"
"tkScaleActivate %W %x %y\n"
"}\n"
"bind Scale <2> {\n"
"tkScaleButton2Down %W %x %y\n"
"}\n"
"bind Scale <B2-Motion> {\n"
"tkScaleDrag %W %x %y\n"
"}\n"
"bind Scale <B2-Leave> { }\n"
"bind Scale <B2-Enter> { }\n"
"bind Scale <ButtonRelease-2> {\n"
"tkCancelRepeat\n"
"tkScaleEndDrag %W\n"
"tkScaleActivate %W %x %y\n"
"}\n"
"bind Scale <Control-1> {\n"
"tkScaleControlPress %W %x %y\n"
"}\n"
"bind Scale <Up> {\n"
"tkScaleIncrement %W up little noRepeat\n"
"}\n"
"bind Scale <Down> {\n"
"tkScaleIncrement %W down little noRepeat\n"
"}\n"
"bind Scale <Left> {\n"
"tkScaleIncrement %W up little noRepeat\n"
"}\n"
"bind Scale <Right> {\n"
"tkScaleIncrement %W down little noRepeat\n"
"}\n"
"bind Scale <Control-Up> {\n"
"tkScaleIncrement %W up big noRepeat\n"
"}\n"
"bind Scale <Control-Down> {\n"
"tkScaleIncrement %W down big noRepeat\n"
"}\n"
"bind Scale <Control-Left> {\n"
"tkScaleIncrement %W up big noRepeat\n"
"}\n"
"bind Scale <Control-Right> {\n"
"tkScaleIncrement %W down big noRepeat\n"
"}\n"
"bind Scale <Home> {\n"
"%W set [%W cget -from]\n"
"}\n"
"bind Scale <End> {\n"
"%W set [%W cget -to]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScaleActivate {w x y} {\n"
"global tkPriv\n"
"if {[$w cget -state] == \"disabled\"} {\n"
"return;\n"
"}\n"
"if {[$w identify $x $y] == \"slider\"} {\n"
"$w configure -state active\n"
"} else {\n"
"$w configure -state normal\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScaleButtonDown {w x y} {\n"
"global tkPriv\n"
"set tkPriv(dragging) 0\n"
"set el [$w identify $x $y]\n"
"if {$el == \"trough1\"} {\n"
"tkScaleIncrement $w up little initial\n"
"} elseif {$el == \"trough2\"} {\n"
"tkScaleIncrement $w down little initial\n"
"} elseif {$el == \"slider\"} {\n"
"set tkPriv(dragging) 1\n"
"set tkPriv(initValue) [$w get]\n"
"set coords [$w coords]\n"
"set tkPriv(deltaX) [expr $x - [lindex $coords 0]]\n"
"set tkPriv(deltaY) [expr $y - [lindex $coords 1]]\n"
"$w configure -sliderrelief sunken\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScaleDrag {w x y} {\n"
"global tkPriv\n"
"if !$tkPriv(dragging) {\n"
"return\n"
"}\n"
"$w set [$w get [expr $x - $tkPriv(deltaX)] \\\n"
"[expr $y - $tkPriv(deltaY)]]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScaleEndDrag {w} {\n"
"global tkPriv\n"
"set tkPriv(dragging) 0\n"
"$w configure -sliderrelief raised\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScaleIncrement {w dir big repeat} {\n"
"global tkPriv\n"
"if {![winfo exists $w]} return\n"
"if {$big == \"big\"} {\n"
"set inc [$w cget -bigincrement]\n"
"if {$inc == 0} {\n"
"set inc [expr abs([$w cget -to] - [$w cget -from])/10.0]\n"
"}\n"
"if {$inc < [$w cget -resolution]} {\n"
"set inc [$w cget -resolution]\n"
"}\n"
"} else {\n"
"set inc [$w cget -resolution]\n"
"}\n"
"if {([$w cget -from] > [$w cget -to]) ^ ($dir == \"up\")} {\n"
"set inc [expr -$inc]\n"
"}\n"
"$w set [expr [$w get] + $inc]\n"
"\n"
"if {$repeat == \"again\"} {\n"
"set tkPriv(afterId) [after [$w cget -repeatinterval] \\\n"
"tkScaleIncrement $w $dir $big again]\n"
"} elseif {$repeat == \"initial\"} {\n"
"set delay [$w cget -repeatdelay]\n"
"if {$delay > 0} {\n"
"set tkPriv(afterId) [after $delay \\\n"
"tkScaleIncrement $w $dir $big again]\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScaleControlPress {w x y} {\n"
"set el [$w identify $x $y]\n"
"if {$el == \"trough1\"} {\n"
"$w set [$w cget -from]\n"
"} elseif {$el == \"trough2\"} {\n"
"$w set [$w cget -to]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScaleButton2Down {w x y} {\n"
"global tkPriv\n"
"\n"
"if {[$w cget -state] == \"disabled\"} {\n"
"return;\n"
"}\n"
"$w configure -state active\n"
"$w set [$w get $x $y]\n"
"set tkPriv(dragging) 1\n"
"set tkPriv(initValue) [$w get]\n"
"set coords \"$x $y\"\n"
"set tkPriv(deltaX) 0\n"
"set tkPriv(deltaY) 0\n"
"}\n"
"";
#line 648 "et41.c"
Et_EvalInclude("scale.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind Scrollbar <Enter> {\n"
"if $tk_strictMotif {\n"
"set tkPriv(activeBg) [%W cget -activebackground]\n"
"%W config -activebackground [%W cget -background]\n"
"}\n"
"%W activate [%W identify %x %y]\n"
"}\n"
"bind Scrollbar <Motion> {\n"
"%W activate [%W identify %x %y]\n"
"}\n"
"bind Scrollbar <Leave> {\n"
"if $tk_strictMotif {\n"
"%W config -activebackground $tkPriv(activeBg)\n"
"}\n"
"%W activate {}\n"
"}\n"
"bind Scrollbar <1> {\n"
"tkScrollButtonDown %W %x %y\n"
"}\n"
"bind Scrollbar <B1-Motion> {\n"
"tkScrollDrag %W %x %y\n"
"}\n"
"bind Scrollbar <B1-B2-Motion> {\n"
"tkScrollDrag %W %x %y\n"
"}\n"
"bind Scrollbar <ButtonRelease-1> {\n"
"tkScrollButtonUp %W %x %y\n"
"}\n"
"bind Scrollbar <B1-Leave> {\n"
"\n"
"}\n"
"bind Scrollbar <B1-Enter> {\n"
"\n"
"}\n"
"bind Scrollbar <2> {\n"
"tkScrollButton2Down %W %x %y\n"
"}\n"
"bind Scrollbar <B1-2> {\n"
"\n"
"}\n"
"bind Scrollbar <B2-1> {\n"
"\n"
"}\n"
"bind Scrollbar <B2-Motion> {\n"
"tkScrollDrag %W %x %y\n"
"}\n"
"bind Scrollbar <ButtonRelease-2> {\n"
"tkScrollButtonUp %W %x %y\n"
"}\n"
"bind Scrollbar <B1-ButtonRelease-2> {\n"
"\n"
"}\n"
"bind Scrollbar <B2-ButtonRelease-1> {\n"
"\n"
"}\n"
"bind Scrollbar <B2-Leave> {\n"
"\n"
"}\n"
"bind Scrollbar <B2-Enter> {\n"
"\n"
"}\n"
"bind Scrollbar <Control-1> {\n"
"tkScrollTopBottom %W %x %y\n"
"}\n"
"bind Scrollbar <Control-2> {\n"
"tkScrollTopBottom %W %x %y\n"
"}\n"
"\n"
"bind Scrollbar <Up> {\n"
"tkScrollByUnits %W v -1\n"
"}\n"
"bind Scrollbar <Down> {\n"
"tkScrollByUnits %W v 1\n"
"}\n"
"bind Scrollbar <Control-Up> {\n"
"tkScrollByPages %W v -1\n"
"}\n"
"bind Scrollbar <Control-Down> {\n"
"tkScrollByPages %W v 1\n"
"}\n"
"bind Scrollbar <Left> {\n"
"tkScrollByUnits %W h -1\n"
"}\n"
"bind Scrollbar <Right> {\n"
"tkScrollByUnits %W h 1\n"
"}\n"
"bind Scrollbar <Control-Left> {\n"
"tkScrollByPages %W h -1\n"
"}\n"
"bind Scrollbar <Control-Right> {\n"
"tkScrollByPages %W h 1\n"
"}\n"
"bind Scrollbar <Prior> {\n"
"tkScrollByPages %W hv -1\n"
"}\n"
"bind Scrollbar <Next> {\n"
"tkScrollByPages %W hv 1\n"
"}\n"
"bind Scrollbar <Home> {\n"
"tkScrollToPos %W 0\n"
"}\n"
"bind Scrollbar <End> {\n"
"tkScrollToPos %W 1\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollButtonDown {w x y} {\n"
"global tkPriv\n"
"set tkPriv(relief) [$w cget -activerelief]\n"
"$w configure -activerelief sunken\n"
"set element [$w identify $x $y]\n"
"if {$element == \"slider\"} {\n"
"tkScrollStartDrag $w $x $y\n"
"} else {\n"
"tkScrollSelect $w $element initial\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollButtonUp {w x y} {\n"
"global tkPriv\n"
"tkCancelRepeat\n"
"$w configure -activerelief $tkPriv(relief)\n"
"tkScrollEndDrag $w $x $y\n"
"$w activate [$w identify $x $y]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollSelect {w element repeat} {\n"
"global tkPriv\n"
"if {![winfo exists $w]} return\n"
"if {$element == \"arrow1\"} {\n"
"tkScrollByUnits $w hv -1\n"
"} elseif {$element == \"trough1\"} {\n"
"tkScrollByPages $w hv -1\n"
"} elseif {$element == \"trough2\"} {\n"
"tkScrollByPages $w hv 1\n"
"} elseif {$element == \"arrow2\"} {\n"
"tkScrollByUnits $w hv 1\n"
"} else {\n"
"return\n"
"}\n"
"if {$repeat == \"again\"} {\n"
"set tkPriv(afterId) [after [$w cget -repeatinterval] \\\n"
"tkScrollSelect $w $element again]\n"
"} elseif {$repeat == \"initial\"} {\n"
"set delay [$w cget -repeatdelay]\n"
"if {$delay > 0} {\n"
"set tkPriv(afterId) [after $delay tkScrollSelect $w $element again]\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollStartDrag {w x y} {\n"
"global tkPriv\n"
"\n"
"if {[$w cget -command] == \"\"} {\n"
"return\n"
"}\n"
"set tkPriv(pressX) $x\n"
"set tkPriv(pressY) $y\n"
"set tkPriv(initValues) [$w get]\n"
"set iv0 [lindex $tkPriv(initValues) 0]\n"
"if {[llength $tkPriv(initValues)] == 2} {\n"
"set tkPriv(initPos) $iv0\n"
"} else {\n"
"if {$iv0 == 0} {\n"
"set tkPriv(initPos) 0.0\n"
"} else {\n"
"set tkPriv(initPos) [expr (double([lindex $tkPriv(initValues) 2])) \\\n"
"/ [lindex $tkPriv(initValues) 0]]\n"
"}\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollDrag {w x y} {\n"
"global tkPriv\n"
"\n"
"if {$tkPriv(initPos) == \"\"} {\n"
"return\n"
"}\n"
"set delta [$w delta [expr $x - $tkPriv(pressX)] [expr $y - $tkPriv(pressY)]]\n"
"if [$w cget -jump] {\n"
"if {[llength $tkPriv(initValues)] == 2} {\n"
"$w set [expr [lindex $tkPriv(initValues) 0] + $delta] \\\n"
"[expr [lindex $tkPriv(initValues) 1] + $delta]\n"
"} else {\n"
"set delta [expr round($delta * [lindex $tkPriv(initValues) 0])]\n"
"eval $w set [lreplace $tkPriv(initValues) 2 3 \\\n"
"[expr [lindex $tkPriv(initValues) 2] + $delta] \\\n"
"[expr [lindex $tkPriv(initValues) 3] + $delta]]\n"
"}\n"
"} else {\n"
"tkScrollToPos $w [expr $tkPriv(initPos) + $delta]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollEndDrag {w x y} {\n"
"global tkPriv\n"
"\n"
"if {$tkPriv(initPos) == \"\"} {\n"
"return\n"
"}\n"
"if [$w cget -jump] {\n"
"set delta [$w delta [expr $x - $tkPriv(pressX)] \\\n"
"[expr $y - $tkPriv(pressY)]]\n"
"tkScrollToPos $w [expr $tkPriv(initPos) + $delta]\n"
"}\n"
"set tkPriv(initPos) \"\"\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollByUnits {w orient amount} {\n"
"set cmd [$w cget -command]\n"
"if {($cmd == \"\") || ([string first \\\n"
"[string index [$w cget -orient] 0] $orient] < 0)} {\n"
"return\n"
"}\n"
"set info [$w get]\n"
"if {[llength $info] == 2} {\n"
"uplevel #0 $cmd scroll $amount units\n"
"} else {\n"
"uplevel #0 $cmd [expr [lindex $info 2] + $amount]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollByPages {w orient amount} {\n"
"set cmd [$w cget -command]\n"
"if {($cmd == \"\") || ([string first \\\n"
"[string index [$w cget -orient] 0] $orient] < 0)} {\n"
"return\n"
"}\n"
"set info [$w get]\n"
"if {[llength $info] == 2} {\n"
"uplevel #0 $cmd scroll $amount pages\n"
"} else {\n"
"uplevel #0 $cmd [expr [lindex $info 2] + $amount*([lindex $info 1] - 1)]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollToPos {w pos} {\n"
"set cmd [$w cget -command]\n"
"if {($cmd == \"\")} {\n"
"return\n"
"}\n"
"set info [$w get]\n"
"if {[llength $info] == 2} {\n"
"uplevel #0 $cmd moveto $pos\n"
"} else {\n"
"uplevel #0 $cmd [expr round([lindex $info 0]*$pos)]\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollTopBottom {w x y} {\n"
"global tkPriv\n"
"set element [$w identify $x $y]\n"
"if [string match *1 $element] {\n"
"tkScrollToPos $w 0\n"
"} elseif [string match *2 $element] {\n"
"tkScrollToPos $w 1\n"
"}\n"
"\n"
"\n"
"\n"
"set tkPriv(relief) [$w cget -activerelief]\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkScrollButton2Down {w x y} {\n"
"global tkPriv\n"
"set element [$w identify $x $y]\n"
"if {($element == \"arrow1\") || ($element == \"arrow2\")} {\n"
"tkScrollButtonDown $w $x $y\n"
"return\n"
"}\n"
"tkScrollToPos $w [$w fraction $x $y]\n"
"set tkPriv(relief) [$w cget -activerelief]\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"update idletasks\n"
"$w configure -activerelief sunken\n"
"$w activate slider\n"
"tkScrollStartDrag $w $x $y\n"
"}\n"
"";
#line 649 "et41.c"
Et_EvalInclude("scrlbar.tcl",_ET_script_); };
  { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkTearOffMenu w {\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"set parent [winfo parent $w]\n"
"while {([winfo toplevel $parent] != $parent)\n"
"|| ([winfo class $parent] == \"Menu\")} {\n"
"set parent [winfo parent $parent]\n"
"}\n"
"if {$parent == \".\"} {\n"
"set parent \"\"\n"
"}\n"
"for {set i 1} 1 {incr i} {\n"
"set menu $parent.tearoff$i\n"
"if ![winfo exists $menu] {\n"
"break\n"
"}\n"
"}\n"
"\n"
"tkMenuDup $w $menu\n"
"$menu configure -transient 0\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"set parent [winfo parent $w]\n"
"switch [winfo class $parent] {\n"
"Menubutton {\n"
"wm title $menu [$parent cget -text]\n"
"}\n"
"Menu {\n"
"wm title $menu [$parent entrycget active -label]\n"
"}\n"
"}\n"
"\n"
"$menu configure -tearoff 0\n"
"$menu post [winfo x $w] [winfo y $w]\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"bind $menu <Enter> {\n"
"set tkPriv(focus) %W\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"set cmd [$w cget -tearoffcommand]\n"
"if {$cmd != \"\"} {\n"
"uplevel #0 $cmd $w $menu\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc tkMenuDup {src dst} {\n"
"set cmd \"menu $dst\"\n"
"foreach option [$src configure] {\n"
"if {[llength $option] == 2} {\n"
"continue\n"
"}\n"
"lappend cmd [lindex $option 0] [lindex $option 4]\n"
"}\n"
"eval $cmd\n"
"set last [$src index last]\n"
"if {$last == \"none\"} {\n"
"return\n"
"}\n"
"for {set i [$src cget -tearoff]} {$i <= $last} {incr i} {\n"
"set cmd \"$dst add [$src type $i]\"\n"
"foreach option [$src entryconfigure $i]  {\n"
"lappend cmd [lindex $option 0] [lindex $option 4]\n"
"}\n"
"eval $cmd\n"
"if {[$src type $i] == \"cascade\"} {\n"
"tkMenuDup [$src entrycget $i -menu] $dst.m$i\n"
"$dst entryconfigure $i -menu $dst.m$i\n"
"}\n"
"}\n"
"\n"
"\n"
"\n"
"regsub -all . $src {\\\\&} quotedSrc\n"
"regsub -all . $dst {\\\\&} quotedDst\n"
"regsub -all $quotedSrc [bindtags $src] $dst x\n"
"bindtags $dst $x\n"
"foreach event [bind $src] {\n"
"regsub -all $quotedSrc [bind $src $event] $dst x\n"
"bind $dst $event $x\n"
"}\n"
"}\n"
"";
#line 650 "et41.c"
Et_EvalInclude("tearoff.tcl",_ET_script_); };
  Et_Eval(__FILE__,__LINE__,"s","proc init {} {# do nothing}; init ");
  Et_Eval(__FILE__,__LINE__,"s","set Win32 0");
  return ET_OK;
}

/*
** Process Tk events until the last window is destroyed, then return.
*/
void
Et_MainLoop(){
    Tk_MainLoop();
}

/*
** Static variables used by the interactive Tcl/Tk processing
*/
static Tcl_DString command;	/* Used to assemble lines of terminal input
				 * into Tcl commands. */
static Tcl_DString line;	/* Used to read the next line from the
                                 * terminal input. */
static int tty;			/* Non-zero means standard input is a
				 * terminal-like device.  Zero means it's
				 * a file. */


/*
 *----------------------------------------------------------------------
 *
 * Prompt --
 *
 *	Issue a prompt on standard output, or invoke a script
 *	to issue the prompt.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	A prompt gets output, and a Tcl script may be evaluated
 *	in interp.
 *
 *----------------------------------------------------------------------
 */

static void
Prompt(interp, partial)
    Tcl_Interp *interp;			/* Interpreter to use for prompting. */
    int partial;			/* Non-zero means there already
					 * exists a partial command, so use
					 * the secondary prompt. */
{
    char *promptCmd;
    int code;
    Tcl_Channel outChannel, errChannel;

    errChannel = Tcl_GetChannel(interp, "stderr", NULL);

    promptCmd = Tcl_GetVar(interp,
	partial ? "tcl_prompt2" : "tcl_prompt1", TCL_GLOBAL_ONLY);
    if (promptCmd == NULL) {
defaultPrompt:
	if (!partial) {

            /*
             * We must check that outChannel is a real channel - it
             * is possible that someone has transferred stdout out of
             * this interpreter with "interp transfer".
             */

	    outChannel = Tcl_GetChannel(interp, "stdout", NULL);
            if (outChannel != (Tcl_Channel) NULL) {
                Tcl_Write(outChannel, "% ", 2);
            }
	}
    } else {
	code = Tcl_Eval(interp, promptCmd);
	if (code != TCL_OK) {
	    Tcl_AddErrorInfo(interp,"\n    (script that generates prompt)");

            /*
             * We must check that errChannel is a real channel - it
             * is possible that someone has transferred stderr out of
             * this interpreter with "interp transfer".
             */
	    errChannel = Tcl_GetChannel(interp, "stderr", NULL);
            if (errChannel != (Tcl_Channel) NULL) {
                Tcl_Write(errChannel, interp->result, -1);
                Tcl_Write(errChannel, "\n", 1);
            }
	    goto defaultPrompt;
	}
    }
    outChannel = Tcl_GetChannel(interp, "stdout", NULL);
    if (outChannel != (Tcl_Channel) NULL) {
        Tcl_Flush(outChannel);
    }
}

/*
 *----------------------------------------------------------------------
 *
 * StdinProc --
 *
 *	This procedure is invoked by the event dispatcher whenever
 *	standard input becomes readable.  It grabs the next line of
 *	input characters, adds them to a command being assembled, and
 *	executes the command if it's complete.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	Could be almost arbitrary, depending on the command that's
 *	typed.
 *
 *----------------------------------------------------------------------
 */

    /* ARGSUSED */
static void
StdinProc(clientData, mask)
    ClientData clientData;		/* Not used. */
    int mask;				/* Not used. */
{
    static int gotPartial = 0;
    char *cmd;
    int code, count;
    Tcl_Channel chan = (Tcl_Channel) clientData;

    count = Tcl_Gets(chan, &line);

    if (count < 0) {
	if (!gotPartial) {
	    if (tty) {
		Tcl_Exit(0);
	    } else {
		Tcl_DeleteChannelHandler(chan, StdinProc, (ClientData) chan);
	    }
	    return;
	} else {
	    count = 0;
	}
    }

    (void) Tcl_DStringAppend(&command, Tcl_DStringValue(&line), -1);
    cmd = Tcl_DStringAppend(&command, "\n", -1);
    Tcl_DStringFree(&line);
    
    if (!Tcl_CommandComplete(cmd)) {
        gotPartial = 1;
        goto prompt;
    }
    gotPartial = 0;

    /*
     * Disable the stdin channel handler while evaluating the command;
     * otherwise if the command re-enters the event loop we might
     * process commands from stdin before the current command is
     * finished.  Among other things, this will trash the text of the
     * command being evaluated.
     */

    Tcl_CreateChannelHandler(chan, 0, StdinProc, (ClientData) chan);
    code = Tcl_RecordAndEval(Et_Interp, cmd, TCL_EVAL_GLOBAL);
    Tcl_CreateChannelHandler(chan, TCL_READABLE, StdinProc,
	    (ClientData) chan);
    Tcl_DStringFree(&command);
    if (*Et_Interp->result != 0) {
	if ((code != TCL_OK) || (tty)) {
	    /*
	     * The statement below used to call "printf", but that resulted
	     * in core dumps under Solaris 2.3 if the result was very long.
             *
             * NOTE: This probably will not work under Windows either.
	     */

	    puts(Et_Interp->result);
	}
    }

    /*
     * Output a prompt.
     */

    prompt:
    if (tty) {
	Prompt(Et_Interp, gotPartial);
    }
    Tcl_ResetResult(Et_Interp);
}

/*
** Make arrangements to read and interpret standard input
*/
void
Et_ReadStdin()
{
  Tcl_Channel inChannel;

  tty = isatty(0);
  inChannel = Tcl_GetStdChannel(TCL_STDIN);
  if (inChannel) {
    Tcl_CreateChannelHandler(inChannel, TCL_READABLE, StdinProc,
                             (ClientData) inChannel);
  }
  if( tty ){
    Et_Eval(__FILE__,__LINE__,"sssssss","\n"
,"if ![info exists tcl_prompt1] {\n"
,"set tcl_prompt1 { puts -nonewline stdout [file tail $argv0]> }\n"
,"}\n"
,"if ![info exists tcl_prompt2] {\n"
,"set tcl_prompt2 { puts -nonewline stdout => }\n"
,"}\n"
);
    Prompt(Et_Interp, 0);
  }
  Tcl_DStringInit(&command);
}

/******* Automatically generated code follows ********/
#ifdef __cplusplus
#  define EXTERN extern "C"
#else
#  define EXTERN extern
#endif
EXTERN void Et_InstallCommand(char *,int (*)(void*,struct Tcl_Interp*,int,char**));
void Et_Init_et41_c(void){
}
