# ------------------------------------------------------------------------------
# Load configuration file
# ------------------------------------------------------------------------------

proc load_config {cfg_file} {
  global palmail_dir modem

  if ![file readable $cfg_file] {return 0}
  if {![catch {open $cfg_file r} file_id]} {
    while {![eof $file_id]} {
      gets $file_id line
      if {"$line" != ""} {
#.......remove leading spaces
        set line [string trimleft $line]
#.......ignore comments
        if {[string index $line 0] != "\#"} {
          set line_list [split $line]
          set var_name  [lindex $line_list 0]
          set var_value [lrange $line_list 1 end]
          global $var_name
          eval set $var_name [join $var_value]
        }
      }
    }
    catch {close $file_id}
  }

}
