# ------------------------------------------------------------------------------
# Ring-Commands
# ------------------------------------------------------------------------------

# Try to play a recorded voice message or view an incoming fax,
# using the file name in the ringlog file

proc do_entry_auto {} {
  global file_list hint_list faxin_dir vocin_dir tmp_file use_modem
  global do_View_n_command do_View_f_command play_cmd

  set items [listbox_selection]
  if {$items == ""} {return 0}

#.collect available files in two lists
  set voc_files ""
  set fax_files ""
  foreach i $items {
    set file [lindex $file_list $i]
    if {$file != ""} {
      set mode [lindex $hint_list $i]
      if {$mode == "fax"} {
#.......it's a fax
#.......convert file name to use wildcards for page numbers
        set file [lindex [split $file "."] 0].*
        if {[llength [glob -nocomplain "$faxin_dir/$file"]] == 0} {
          log_entry "$file doesn't exist any more"
        } else {
          lappend fax_files "$file"
        }
      } else {
#.......it's a voice message
        if ![file exists $vocin_dir/$file] {
          log_entry "$file doesn't exist any more"
        } else {
          lappend voc_files "$vocin_dir/$file"
        }
      }
    }
  }

#.first display all fax pages simultaneously in the background
  foreach i $fax_files {
#...determine fax resolution
    set res [string index $i 1]
#...collect all pages
    set f [glob -nocomplain "$faxin_dir/$i"]
    log_entry "$i: Viewing files"
    set command "do_View_${res}_command 2> $tmp_file &"
    if [catch "eval eval exec $$command"] {
      log_entry "$i: Viewing files -- failed"
    }
#...look for error-messages
    after 500
    if {[file exists $tmp_file] && [file size $tmp_file]} {
      log_entry [read_file "" $tmp_file]
    }
  }
  catch "eval exec rm -f $tmp_file"

#.then play all the voice messages
  if {"$voc_files" != ""} {
    set n1 [file tail [lindex $voc_files 0]]
    set n2 [file tail [lindex $voc_files [expr [llength $voc_files] - 1]]]
    if {[llength $voc_files] == 1} {log_entry "$n1: Playing file"} \
    else {log_entry "$n1 .. $n2: Playing files"}
    if ![stop_play] {return 0}
    if $use_modem {
      set args [concat play modem $voc_files]
    } else {
      set args [concat play soundcard $voc_files]
    }
    exec_cmd $play_cmd $args play_pid
  }
}


# ATA: pick up the phone

proc do_ata {} {
  global mgetty_pid do_Ata_command
  log_entry "Pick up"
  if {[file exists $mgetty_pid] && [file size $mgetty_pid]} {
    set pid [read_file -nonewline $mgetty_pid]
    if [catch "eval exec $do_Ata_command"] {log_entry "Pick up -- failed"}
  }
}


# Update ringlog file

proc update_ringlog {} {
  global curr_dir curr_file mgetty_log fax_db

#.is mgetty-log newer than ringlog?
  if {![file readable $mgetty_log] || ![file readable $curr_dir/$curr_file] || \
      [file mtime $mgetty_log] < [file mtime $curr_dir/$curr_file]} {return 0}
#.call external procedure
  update_ringlog_c
  catch "eval exec touch $curr_dir/$curr_file"
}

